	program aesmooth7a
C........................................................................Aug. 2015
C
C Produce 7h smoothed AE
C
C                    
      DIMENSION IM(12),DA(366,0:24)
	DIMENSION IXDEV(0:23),xx(0:71) ! 3 days array
	+,ires(0:23),AES(366,0:24)
	CHARACTER*22 INFILE
	CHARACTER*2 AYR,AMN,ADY
	CHARACTER*25 OUTFILE
	CHARACTER*4 SYEAR
	CHARACTER*10 YRINP,RE(366),D1,D2,DM,DD1,DD2,DDM
	+,YRINP1
	REAL YEAR
	COMMON AES
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	icnt=0
 100	WRITE(*,'(A\)') ' ENTER YEAR    :'
      READ (*,*) SYEAR
	READ (SYEAR,*) YEAR
	YEAR1=YEAR
	INFILE='aeYEAR.tot'
	OUTFILE='aeYEARs.txt'
	OUTFILE(3:6)=SYEAR
	INFILE(3:6)=SYEAR
      IF ((YEAR/4.).EQ.IFIX(YEAR/4.)) THEN 
	IM(2)=29 
	IDNR=366
	ELSE 
	IM(2)=28
	IDNR=365
	ENDIF
C Put initials: D1,IT1,DM,IDAY,AVER,AMIN,IUTMIN,D2,IT2,IUTT,ADST
	DD1=''
	DD2=''
	DDM=''
	IIT1=24
	IIT2=24
	IIDAY=0
	AAVER=0.
	AAMIN=0.
	IIUTMIN=24
	IIUTT=0
	AADST=0.
	IFL=0
C End of initials

	OPEN(11,FILE=INFILE)
		OPEN(12,FILE=OUTFILE)	
	if (YEAR1.eq.YEAR) then
C	READ(11,12,END=2,ERR=99) YRINP,XDEV
	write(*,*) 'Enter AE-3, AE-2,AE-1 for DEC 31 Prec Year:'
	read(*,*) xx(45)
	read(*,*) xx(46)
	read(*,*) xx(47)
C-	xx(45)=xdev(0)
C-	xx(46)=xdev(0)
C-	xx(47)=xdev(0)
C	backspace(11)
	endif

	DO 15 J=1,IDNR
	do i=0,23
	xx(i)=xx(i+24) ! prec day
	enddo
	YRINP=YRINP1
	AYR=YRINP(1:2)
	AMN=YRINP(3:4)
	ADY=YRINP(5:6)
	if (j.eq.1) then
	read(11,*,END=2,ERR=99) xxx
	backspace(11)
	READ (11,12,END=2,ERR=99) YRINP,IXDEV ! 1st day of year
	AYR=YRINP(1:2)
	AMN=YRINP(3:4)
	ADY=YRINP(5:6)
	do i=0,23
	xx(i+24)=float(ixdev(i)) ! current day
	enddo
	            else
	do i=0,23
	xx(i+24)=xx(i+48) ! current day
	enddo
	endif 
	if (j.lt.idnr) then
	READ (11,12,END=2,ERR=99) YRINP1,IXDEV	   !next day
	do i=0,23
	xx(i+48)=float(ixdev(i)) ! next day
	enddo
	    else
	write(*,*) 'Enter AE+1, AE+2,AE+3 for JAN 1 Next Year:'
	read(*,*) xx(48)
	read(*,*) xx(49)
	read(*,*) xx(50)

C-	xx(48)=xx(47)
C-	xx(49)=xx(47)
C-	xx(50)=xx(47)
	endif
	i1=20
	do ii=0,23
	i1=i1+1
	sum=0.
	do kk=1,7
	sum=sum+xx(i1+kk-1)
	enddo
	ires(ii)=nint(sum/7.)
	enddo
  112	FORMAT(A134)
   12  FORMAT(A6,24(1X,I4))
   13  FORMAT('AE',1X,2A2,'*',A2,10X,24(I4))
	RE(J)=YRINP
	write(*,13) AYR,AMN,ADY,(ires(K),k=0,23)
	write(12,13) AYR,AMN,ADY,(ires(K),k=0,23)
	DO ii=0,23
	AES(j,ii)=float(ires(ii))
	ENDDO
	GOTO 15
C Calculation of daily mean:
	DAV=0.
	DO 14 K=0,23
	DA(J,K)=float(ixdev(K))
	DAV=DAV+float(IXDEV(K))
   14 CONTINUE
	DA(J,24)=DAV/24.
   15 CONTINUE

   2   CONTINUE
       CLOSE (UNIT=11)
	GOTO 811           !>>>>>>>>>>>>>>>>>>>>>>>
c
C		OPEN(12,FILE=OUTFILE,ACCESS='APPEND')	
      DO 810 J=1,IDNR
C ++++++ Record results for preceding solution:
C	D1,IT1,DM,IDAY,AVER,AMIN,IUTMIN,D2,IT2,IUTT,ADST
	IIFL=IFL
	       IF ((J.GT.1).AND.(IFL.EQ.1)) THEN
	DD1=D1
	DD2=D2
	DDM=DM
	IIT1=IT1
	IIT2=IT2
	IIDAY=IDAY
	AAVER=AVER
	AAMIN=AMIN        !AEmax
	IIUTMIN=IUTMIN
	IIUTT=IUTT
	AADST=ADST
	       ENDIF

      AMIN=0.
	CNT=0
	
      DO K=0,23
      IF (DA(J,K).GT.AMIN) THEN 
	AMIN=DA(J,K) 
	IUTMIN=K
	ENDIF
	ENDDO

      IF (AMIN.GE.500.) THEN 		  ! AEpeak>=500.0 nT
	  IFL=1
	  GOTO 710
	ELSE
	  IFL=0
        IF (IIFL.EQ.1) THEN
	  GOTO 790
	            ELSE
	  GOTO 805
	           ENDIF
	ENDIF
	
C GO TO SUBROUTINE DETECTING <STORM-START;STORM-END> USING KPYR.D27
  710 CONTINUE
      D1='' 
      D2=''
	IT1=0
	IT2=0
	ADST=0.
	IDAY=J

	CALL DETECTAE(IDAY,RE,D1,IT1,D2,IT2,IUTT,ADST,IUTMIN)
	AVER=DA(J,24)
	DM=RE(J)
C

	IF ((D1.EQ.DD1).AND.(D2.EQ.DD2).AND.(IIUTT.EQ.IUTT)) THEN
	IF (J.EQ.IDNR) GOTO 800
	   IF (AMIN.GT.AAMIN) THEN

	       GOTO 805
	                      ELSE
	D1=DD1
	D2=DD2
	DM=DDM
	IT1=IIT1
	IT2=IIT2
	IDAY=IIDAY
	AVER=AAVER
	AMIN=AAMIN
	IUTMIN=IIUTMIN
	IUTT=IIUTT
	ADST=AADST
	IFL=IIFL
	      
	   ENDIF
	                                                ELSE
	if (iifl.eq.1) then
	goto 790
	 else
	      IF (J.EQ.IDNR) THEN 
		  GOTO 800
	                     ELSE
	      GOTO 805
	                     ENDIF
	endif
	                                                ENDIF
	GOTO 805
  790	CONTINUE
	icnt=icnt+1
 	WRITE(*,170) icnt,DD1,IIT1,DDM,IIUTMIN,AAMIN,DD2,IIT2,IIUTT
 	WRITE(12,170) icnt,DD1,IIT1,DDM,IIUTMIN,AAMIN,DD2,IIT2,IIUTT
crem 	WRITE(12,170) DD1,IIT1,DDM,IIUTMIN,IIDAY,AAVER,AAMIN,DD2
crem	&,IIT2,IIUTT,AADST
crem      WRITE(*,170) DD1,IIT1,DDM,IIUTMIN,IIDAY,AAVER,AAMIN,DD2
crem 	&,IIT2,IIUTT,AADST
crem  170	FORMAT(1X,A10,I3,2X,A10,I3,1X,I3,2F6.0,2X,A10,I3,1X,I4,F6.0)
  170	FORMAT(1X,I4,1X,A10,I3,2X,A10,I3,1X,F6.0,2X,A10,I3,1X,I4)
	if (j.lt.idnr) goto 805
  800	CONTINUE
crem	WRITE(12,170) D1,IT1,DM,IUTMIN,IDAY,AVER,AMIN,D2,IT2,IUTT,ADST
crem	WRITE(*,170) D1,IT1,DM,IUTMIN,IDAY,AVER,AMIN,D2,IT2,IUTT,ADST
	icnt=icnt+1
	WRITE(*,170) icnt,D1,IT1,DM,IUTMIN,AMIN,D2,IT2,IUTT
	WRITE(12,170) icnt,D1,IT1,DM,IUTMIN,AMIN,D2,IT2,IUTT
C	PAUSE ' '
  805	IIFL=IIFL+1
	
  810 CONTINUE
C
C
  811    CLOSE (UNIT=12)
	CALL subaestorm2a(SYEAR)
CREM     YEAR=YEAR+1
CREM      IF (YEAR.LT.2015) GOTO 100
   99	CONTINUE
	write(*,*) YRINP1,IXDEV	
C	CLOSE (UNIT=112)
	pause ' '
      STOP
	END
C******************************************************************************
C      SUBROUTINE TO DETECT <STORM-START;STORM-END>
	SUBROUTINE DETECTAE(JDAY,RE,D1,IT1,D2,IT2,IUT,AADST,IMX)
	DIMENSION DA(366,0:24)
	CHARACTER*10 D1,D2,RE(366)
	INTEGER C1,C2
	COMMON DA
	
C START-OF-STORM DETECTING================
      J1=JDAY
	J2=JDAY
	 C2=-1
       K2=IMX
C  PRINT IMX,DEX 
  970    C1=-1  
	K1=23
      IF (J1.EQ.JDAY) K1=IMX
      K=K1
 1000 CONTINUE
C      WRITE(*,*) J1,K,DA(J1,K)
      IF (DA(J1,K).GE.300.) THEN 
	C1=K  
	GOTO 1030
	                     ELSE
      ISTR1=K+1 
	GOTO 1060
	ENDIF
 1030 K=K-1
      IF (K.GE.0) GOTO 1000
      IF (C1.GE.0) THEN 
	J1=J1-1 
	GOTO 970
	ENDIF

 1060  IF (ISTR1.LT.24) GOTO 1080
      J1=J1+1 
	 ISTR1=0
 1080  D1=RE(J1)
      IT1=ISTR1 
C      WRITE(*,*) D1,IT1 
C	PAUSE ' '
C DERIVE DURATION OF THE MAIN PHASE OF STORM:=========== 
 1290 IAV=IMX-ISTR1+1+(JDAY-J1)*24
	DSTAV=0.
1100	CONTINUE
	DO JA=J1,JDAY
	   IF (JA.EQ.J1) THEN
	     I0=ISTR1
	                 ELSE
	     I0=0
	   ENDIF 

	   IF (JA.LT.JDAY) THEN
	    IK=23
C	    JB=JA+1
	                   ELSE
	    IK=IMX
C	    JB=JDAY
	   ENDIF
		dstav=dstav+DSTAVER(JA,JA,I0,IK)
	ENDDO
C DETECTING OF END-OF-STORM =================
C Check of Dstaver<-30. nT:
 1300	CONTINUE
C UT-end of storm:
 1150 IT2=K2
	JEND=J2
      K2=K2+1
      IF (K2.GT.23) THEN
	J2=J2+1
	K2=0
	ENDIF
C+ 1160	IF (DA(J2,K2).LE.-25.) THEN
 1160	IF (DA(J2,K2).GE.300.) THEN
      DSTAV=DSTAV+DA(J2,K2)
	IAV=IAV+1
	GOTO 1150
                          	ELSE
		     AADST=DSTAV/IAV
C STORM DURATION=========== 
	     IUT=IAV
	                         ENDIF
 1240 D2=RE(JEND)
    
C PRINT D2,IT2
        RETURN
	END
C
C*****************************************************