      program aesioc3
C......................................................Apr. 2015
C AE and AE proxy storms for 1999-2013
C
C.......................................................Mar. 2013
C Select vnjoc & vpjoc for 7 hrs prior AEstorm start, and 41 hrs after Dstmin =48 hrs

C.......................................................Mar. 2009
C 
C Input AEstart (min of AE): yr,mn,dy,UT storm start; 
C
C
C Input AEstorm2.txt = 92 storms for 1999-2013	
C
C
C 1) Select periods of AE storms (hour by hour UT)
C
C 2) Combine arrays during AE storms (1) AE data; (2) AEs (3) AEs/AEspeak
C 
C
c AE and AEs collected for UT: 0, 1, ...,23 hrs
c
	DIMENSION im(12),dst(0:23),aes(0:23)
	+,aedat(92),idst(48,92),iaes(48,92),aep(48,92)
	+,ae3(0:95),aes3(0:95),aep3(0:95)  ! 4 days UT data
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64 outfile,infileb1,infileb2
	+,infildst
      CHARACTER*2 AYR,AMN,ADY,AMN1,AMN2,CDY,CMN
	CHARACTER*2 AUT,DYR,DMN,DMN1,DMN2,DMN3,DDY,DDY1,DDY2,DDY3,XUT
	+,wyr(92),wmn(92),wdy(92),wut(92)
		CHARACTER*128 title
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

      outfile='aesioc3.txt' ! for AEstorm2.txt input 
C
	OPEN(112,FILE=OUTFILE,ACCESS='APPEND')

C start = Enter AEs storms Catalog

C% AE proxy storms and substorms; AE smoothed 7 h peak >=900. nT
C    1 AE 9902*18  2  AE 9902*18 11   940.  AE 9902*19 17   40

	infildst='AEstorm2.txt'
  801	format(A64)
  802	format(9X,2(A2),1X,A2,1X,I2,16X,F5.0)     ! NEW READING START OF AEs STORM
	OPEN(10,FILE=infildst,ACTION='READ')
	read(10,801) title
	jend=0
	DO j=1,92
	read(10,802,end=800) wyr(j),wmn(j),wdy(j),iut,aedat(j) !Start of AEs storm
	jend=jend+1
	call blet2(iut,AUT)
	wut(j)=aut
	enddo
  800	close (unit=10)
  305	format(2(1X,I4),1X,F6.0)
C ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C Cycle on AEs storms
      nst1=0	
C
  805	DO 870 nn=1,jend
C
	adst=aedat(nn)
C 
	jj=0 ! count successive UT records
	nst1=nst1+1
	write(*,305) nst1,nn,adst
	write(112,305) nst1,nn,adst
	do j=0,71
	ae3(j)=0.
	aes3(j)=0.
	aep3(j)=0.
	enddo
C
	ayr=wyr(nn)
 	read(ayr,*) ryr
	jyr=int(ryr)
	cmn=wmn(nn)
 	read(cmn,*) rmn
	jmn=int(rmn)
	cdy=wdy(nn)
 	read(cdy,*) rdy
	jdy=int(rdy)
	lda=ndoy(jyr,jmn,jdy)
	lda1=lda-1
C	if (lda1.le.0) then
C	lda1=lda
C	endif
	lda2=lda+1
	call submmdd(lda1,jyr,jmn1,jdy1) 
	call submmdd(lda2,jyr,jmn2,jdy2) 
	call blet2(jmn1,AMN1)
	call blet2(jmn2,AMN2)
	xut=wut(nn)
 	read(xut,*) rut
	jut=int(rut)
	jut1=jut
	jut2=jut

C
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
  	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
  196	format(A12)
  195	format(A128)
C
  809	continue
C Open AE file to select AE
  	infileb1='d:/Apkp/ae20YR'		 !

	infileb1(13:14)=AYR
	if (jyr.gt.14) then
	infileb1(11:12)='19'
	                 else
	infileb1(11:12)='20'
	endif
      OPEN(34,FILE=infileb1,ACTION='READ')		!AEYEAR file

C Data for prec day:

	do id=1,lda1
	READ(34, 197, END=855) DYR,DMN1,DDY1,(DST(k),k=0,23) ! 
	enddo
  197 format(3X,2A2,1X,A2,10X,24(F4.0))
	do j=0,23
	ae3(j)=dst(j)  ! prec. day
	enddo
  855 CONTINUE

C Data for curr day:

  	READ(34, 197, END=1855) DYR,DMN,DDY,(DST(k),k=0,23) ! current day
	do j=0,23
	ae3(j+24)=dst(j)  ! curr. day
	enddo
 1855 CONTINUE

C Data for next-1 day:

	READ(34, 197, END=2855) DYR,DMN2,DDY2,(DST(k),k=0,23) ! next-1 day
	do j=0,23
	ae3(j+48)=dst(j)  ! next-1 day
	enddo
 2855 CONTINUE

C Data for next-2 day:

	READ(34, 197, END=3855) DYR,DMN3,DDY3,(DST(k),k=0,23) ! next day
	do j=0,23
	ae3(j+72)=dst(j)  ! next-2 day
	enddo
 3855 CONTINUE
	close(unit=34)
C
	infileb2=infileb1	 ! AE smoothed
	infileb2(15:15)='s'
      OPEN(35,FILE=infileb2,ACTION='READ')		!AEYEARs file

C Data for prec day:

	do id=1,lda1
	READ(35, 197, END=856) DYR,DMN1,DDY1,(AES(k),k=0,23) ! 
	enddo
	do j=0,23
	aes3(j)=aes(j)  ! prec. day
	enddo
  856 CONTINUE

C Data for curr day:

  	READ(35, 197, END=1856) DYR,DMN,DDY,(AES(k),k=0,23) ! current day
	do j=0,23
	aes3(j+24)=aes(j)  ! curr. day
	enddo
 1856 CONTINUE

C Data for next-1 day:

	READ(35, 197, END=2856) DYR,DMN2,DDY2,(AES(k),k=0,23) ! next-1 day
	do j=0,23
	aes3(j+48)=aes(j)  ! next-1 day
	enddo
 2856 CONTINUE

C Data for next-2 day:

	READ(35, 197, END=3856) DYR,DMN3,DDY3,(AES(k),k=0,23) ! next-2 day
	do j=0,23
	aes3(j+72)=aes(j)  ! next-2 day
	enddo
 3856 CONTINUE
	close(unit=35)

C
  194 format(3A2,24(1X,I4))

C Select data from jut-7 to jut+41:
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	jut1=24+jut-7
	jut2=jut1+47
	jres=jut-8
	kk=0
	DO jout=jut1,jut2
	kk=kk+1
	dstut=ae3(jout)
	aesut=aes3(jout)
	aeprox=aesut/adst

      idst(kk,nn)=int(dstut)
      iaes(kk,nn)=int(aesut)
	aep(kk,nn)=aeprox
c	jres=jout-24
	jres=jres+1
	if (jres.lt.0) jres=jres+24
	if (jres.gt.23) jres=jres-24
	call blet2(jres,AUT)
C
	amn=dmn
	ady=ddy
	if (jout.lt.24) then
	amn=dmn1
	ady=ddy1
	 endif
	if (jout.gt.47) then
	amn=dmn2
	ady=ddy2
	 endif
	if (jout.gt.71) then
	amn=dmn3
	ady=ddy3
	 endif
	write(*,272) AYR,AMN,ADY,aut,dstut,aesut,aeprox
	write(112,272) AYR,CMN,cdy,aut,dstut,aesut,aeprox
	ENDDO
C
C 
C851	 CONTINUE	   ! END of CYCLE ON EVENT
C	close(unit=34)
C	close(unit=35)
  870	continue			 ! next event
270   format(72(1X,I4))  
   71	format(A64)
   82	format(2A2,I2,24(1X,I4))
  273   format(48(1X,I4))
  274   format(48(1X,F5.2))
  272   format(1X,3A2,1X,A2,2(1X,F5.0),1X,F5.2)

	write(112,*) ' AE '
      do kk=1,92
	write(*,273) (idst(k,kk),k=1,48)
	write(112,273) (idst(k,kk),k=1,48)
	enddo
	write(112,*) ' AEs'
      do kk=1,92
	write(*,273) (iaes(k,kk),k=1,48)
	write(112,273) (iaes(k,kk),k=1,48)
	enddo
	write(112,*) ' AE proxy'
      do kk=1,92
	write(*,274) (aep(k,kk),k=1,48)
	write(112,274) (aep(k,kk),k=1,48)
	enddo
		CLOSE(unit=112)
	goto 900                ! 
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 continue
      pause ' '
      STOP
      END


C ====================================================================
