C............................................................Feb. 2017
C
C TEC(tau) monthly mean 
C
C
      program avermon
C
      DIMENSION im(12)
      character*2 ayr,amn,byr,bmn,bdy
	character*45 infile,outfile
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
c
      infile='tecnoon27.txt'
	outfile='tecmon27.txt'
	OPEN(10,file=infile,action='READ')
	OPEN(11,file=outfile)
   71	format(1X,3A2,1X,F5.1)
C
   1	continue
	do 40 iyy=98,117
	iyear=iyy+1900
C
	if (iyy.lt.100) then
	iyr=iyy
	else
	iyr=iyy-100
	endif
	call blet2(iyr,AYR)
	ryr=float(iyr)
	if(int(ryr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
      mn1=1
	mn2=12
	if (iyy.eq.98) mn1=10
	if (iyy.eq.117) mn2=1
C++  Cycle on mn-to-mn =========================
	DO 80 imn=mn1,mn2
	call blet2(imn,AMN)
	ndnr=im(imn)
C
	sum=0.
      do idy=1,ndnr
	read(10,71,end=41) BYR,BMN,BDY,tec
	sum=sum+tec
	enddo
	avmon=sum/ndnr
	ryear=iyear+imn/12.-0.083
      write(*,72) ryear,AMN,avmon
	write(11,72) ryear,AMN,avmon
   80	continue
   40	continue
   41	close(unit=10)
      close(unit=11)
       GOTO 33
   72	format(1X,F7.2,1X,A2,1X,F5.1)
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
	close(unit=110)
      write(*,*) infile,outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END