CC	
      PROGRAM CORKPSSN2
C T.L.Gulyaeva.............................................Sep. 2016
C Using only kpyr.txt
C
	CHARACTER*2 AMN,AYR,ADY
	+,CYR,CMN,CDY,BYR,BMN,BDY
	CHARACTER*56 infilekp,infile2,outfile,tline
	CHARACTER(10) DD
	CHARACTER(5) ZZ
	CHARACTER(10) TT
		CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)

C temp start SSN2 => SSN1 regr. calculation from 01.07.2015
CTEMP 	AYR='15'
CTEMP	AMN='07'
      AYR='16'
	AMN='01'
	ADY='01'
C
	CYR=DD(3:4)
	 CMN=DD(5:6)
	CDY=DD(7:8)

	outfile='kp20yr.res'
	outfile(5:6)=AYR
	OPEN(11,file=outfile,access='APPEND')
C
	iflag=1   ! for current date
	if ((CYR.eq.AYR).and.(CMN.eq.AMN).and.(CDY.eq.ADY)) goto 123
	CYR=AYR
	CMN=AMN
	CDY=ADY
C Add SSN2:
  123    infile2='SSN220082016.txt'
  112	format(2X,3A2,2X,I3)
	OPEN(10,file=infile2,action='READ')
  111	read(10,112,end=101) CYR,CMN,CDY,ISSN2 ! extra lines
	if ((CYR.eq.AYR).and.(CMN.eq.AMN).and.(CDY.eq.ADY)) then
	backspace(10)
	goto 161
	else
	goto 111
	endif
C 
  161     infilekp='d:\web\graf\kp20ar'
  	infilekp(17:18)=AYR        ! 
C
	read(ayr,*) ryr
	iyr=int(ryr)
	read(amn,*) rmn
	imn=int(rmn)
	read(ady,*) dend
	idy=int(dend)
C
	lda=ndoy(iyr,imn,idy)
	id1=idy
C
	OPEN(19,file=infilekp,action='READ')
	icnt=0
  116	read(10,112,end=101) CYR,CMN,CDY,ISSN2 !
C-	do j=1,lda
  115	READ(19,100,err=139,end=101) BYR,BMN,BDY,tline,irz,cov
  100 format(3A2,A56,I3,F6.2)
	if (icnt.gt.0) then 
	goto 114
	else
	goto 138
	endif
  139	write(*,*) 'No k-index file'
	pause ' '
      stop
C  138 read(10,112,end=101) CYR,CMN,CDY,ISSN2 !
      
  138 if ((CYR.eq.BYR).and.(CMN.eq.BMN).and.(CDY.eq.BDY)) then
	goto 114
	else
	write(*,100)  BYR,BMN,BDY,tline,irz,cov
	write(11,100)  BYR,BMN,BDY,tline,irz,cov
	GOTO 115
	endif
  114		icnt=icnt+1
  	ssn1=0.6925*issn2-0.2452
 	if (ssn1.lt.0.0) ssn1=0.0
	issn1=nint(ssn1)
	write(*,100)  BYR,BMN,BDY,tline,issn1,cov
	write(11,100)  BYR,BMN,BDY,tline,issn1,cov
	GOTO 116
  101 continue
      close(unit=10)
	close(unit=11)
  30	close(unit=19)
	goto 162
 162  pause ' '
      STOP
      end

C
C-----------------------------------------------------------------
C
      subroutine blet2(ilet,alet2)
c

	CHARACTER*1 IN(0:9)
	integer*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
	a2='00'
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
C-----------------------------------------------------------------
C
      subroutine blet3(ilet,alet3)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*3 alet3
	a3='000'
C
	j100=ilet/100
	      j10=(ilet-j100*100)/10
	j1=ilet-j100*100-j10*10
    3	do i=0,9
		if (j100.eq.i) then
	alet3(1:1)=IN(i)
	endif
	enddo
    5	do i=0,9
	if (j10.eq.i) then
	alet3(2:2)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet3(3:3)=IN(i)
	endif
	enddo 
	return
	end
C-----------------------------------------------------------------
      integer function ndoy(iyr,imn,idy)
C To define day-of-year
C
	       DIMENSION IM(12)
c	integer*2 iyr,imn,idy
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	z1=iyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+idy	
	END FUNCTION
C ===============================================================
