C ===========================================================
	PROGRAM EXTSEC14
C..................................................July 2013
C Use subsec2 subroutine 
C Limit to 64 stations
C------------------------------------------------------------
C
C Send results/read source files in directories:
C    web/graf/dat1/13/	   foF2
C    web/graf/dat5/13/	   M3000
C    web/graf/dat6/13/	   hmF2
C For new month, provide 4 header lines
C
C+.................................................Feb. 2013
C+ include model subdlogh.for, to produce model hmF2
C+
C..................................................Oct. 2012     !
C Add Harmonic filling missed data of foF2, hmF2, Tec		       !
C Arrange subfur forecast of foF2, hmF2, tec for two days ahead  !
C
C Send output results to d:\web\idce\styr.br files..................23.12.2009
C
c
      DIMENSION IF2(32,0:23),IM3(32,0:23),IH2(32,0:23),	 !			  !
     *glat(64),glon(64),cglat(64),cglon(64) 	      !
	*,xmlat(64)             !OK add magnetic latitudes
     *,IM(0:12)                                    !
	+,xdat(5,0:23),hmed(0:23),fmed(0:23),ydat(8,0:23)
	+,imedf(0:23),imedh(0:23)
	real rzar(12,8)         ! Monthly Data R12 for 2006,2007,...,2013		
      DIMENSION ictf(8,0:23),icth(8,0:23),ictm(8,0:23)
	INTEGER*2 NFULF,NFULM,MAXD2
     *,idy1,idy2,icdy                 !
     *,imn0,iyr0,idy0,iyr,imn,jd
     *,iyr1,imn1,imn_pre,iyr_pre                    !
      CHARACTER*128 infile,outfile1,outfile2,outfile3	  !
	+,outmedf,outmedh,infile1,infile2,infile3,ATEXT(35),TEXT,ctext
	+,infilbr1,infilbr2,infilbr3  ! from /graf/20132/styrf.br
	+,infilrem,out1,out2,out3
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*30 STNAME 						   !
	CHARACTER*15 STITLE(64),TITLES
	CHARACTER*4 YEAR,TTT
	CHARACTER*6 YYMMDD
	LOGICAL NEWMN  
	CHARACTER*9	IONO  
	CHARACTER*10 CCM
c	*,title
C     +,aa                                    ! 
 	CHARACTER*2 ST,AYR,AMN,DY1,DY2,DDD,DD1,DD2,BYR,BMN,BDY  !
	+,CYR,CMN,CDY,XYR,XMN,XDY											 
     *,FULF(64),FULM(64),DY22,STS(64)				             !
     *,AMN0,AYR0,ADY0,CCF,AYR_PRE,AMN_PRE                            !
	+,CF2(0:23),CH2(0:23),CM2(0:23)
	DATA IM/31,31,28,31,30,31,30,31,31,30,31,30,31/    !
C! Monthly Data R12 for 2008,2009,...,2013		
	DATA RZAR/
     * 20.8,18.6,17.4,17.1,17.3,16.3,15.3,15.6,15.6,14.2,12.6,12.1
     *,11.9,11.5,10.7, 9.9, 8.7, 7.7, 7.0, 6.0, 5.9, 6.0, 5.7, 4.9
     *, 4.2, 3.6, 3.3, 3.4, 3.5, 3.3, 2.8, 2.7, 2.3, 1.8, 1.7, 1.7
     *, 1.8, 1.9, 2.0, 2.2, 2.3, 2.7, 3.6, 4.8, 6.2, 7.1, 7.6, 8.3
     *, 9.3,10.6,12.3,14.0,15.5,16.4,16.7,17.4,19.6,23.2,26.5,28.8
     *,30.9,33.4,36.9,41.8,47.6,53.2,57.2,59.0,59.5,59.9,61.1,63.4  
     *,65.5,66.9,66.8,64.6,61.7,58.9,57.7,60.2,62.9,64.8,65.4,66.8
     *,68.8,70.7,72.0,72.1,72.6,73.8,73.7,72.5,71.9,71.8,72.6,73.1/ 
	DATA STS/'at','bp','bc','br','cn','cb','cw','ch','cq','cs'
	+,'dw','db','ea','ga','gm','gr','gu','ha','he','ho'
     +,'ic','jj','jm','jr','kh','kk','lm','lg','mq','ml'
     +,'mw','mh','mo','mm','nd','ni','ok','pe','ps','pq'
     +,'rm','ro','sj','sq','qn','eb','tr','tv','wk','wp'
     +,'wz','yg','mg','ns','rv','sd','tk','tz','ad','so'
     +,'lv','au','cl','cr'/
      
  	DATA STITLE/
     * 'Athens         ','Beijing        ','Boulder        '
     +,'Brisbane       ','Camden         ','Canberra       '
     +,'Casey          ','Chilton        ','Chongqing      '
     +,'Cocos_Is       ','Darwin         ','Dourbes        '
     +,'ElArensillo    ','Gakona         ','Gibilmanna     '
     +,'Grahamstown    ','Guangzhou      ','Hainan         '
     +,'Hermanus       ','Hobart         ','I_Cheon        '
     +,'Jeju           ','Jicamarca      ','Juliusruh      '
     +,'Khabarovsk     ','Kokubunji      ','Learmonth      '
     +,'Longyearbyen   ','MacQuarue_Is   ','Manzhouli      '
     +,'Mawson         ','Millstone_Hill ','Moscow         '
     +,'Murmansk       ','Niue           ','Norfolk_Is     '
     +,'Okinawa        ','Perth          ','Port_Stanley   '
     +,'Pruhonice      ','Ramey          ','Rome           '
     +,'St_Johns       ','Scott_Base     ','Qaanaaq        '
     +,'Roquetes       ','Tromso         ','Townsville     '
     +,'Wakkanai       ','Wallops        ','Warsaw         '
     +,'Yamagawa       ','Magadan        ','Novosibirsk    '
     +,'Rostov         ','Salehard       ','Tomsk          '
     +,'Tunguska       ','Ashkhabad      ','Sodankyla      '
     +,'Louisvale      ','Austin         ','Chung-Li       '
     +,'Christchurch   '/

C+			  Add magnetic latitudes for subdlogh
	DATA XMLAT/
     *  36.7, 30.1, 48.1,-34.3,-41.0,-42.5,-76.3, 53.8, 19.5,-22.0
     +,-21.3, 51.3, 40.6, 63.7, 37.6,-34.2, 13.2,  8.3,-34.1,-50.2
     +, 27.6, 24.0, -2.0, 54.1, 39.5, 27.1,-31.9, 74.8,-59.9, 39.7
     +,-73.2, 52.6, 51.2, 63.6, 14.2,-33.6, 16.9,-41.9,-42.0, 49.5
     +, 28.4, 41.9, 56.9,-79.0, 87.4, 43.0, 67.3,-27.3, 36.9, 47.8
     +, 50.5, 19.9, 52.2, 45.4, 42.7, 58.3, 47.1, 52.0, 31.1, 64.0
     +,-28.6, 39.3, 15.2,-47.1/

	COMMON /BL1/ST,YEAR,AYR,AMN,DY1,DY2,DD1,DD2,IDY1,IDY2,JF,JH,JT
	+,DY22,STNAME
      COMMON /BL4/ FULF,FULM,NFULF,NFULM,MAXD2
	COMMON /BSTAT/ STS1,STITLE1,STP1,GLON,GLAT,CGLON,CGLAT

C Start:
C    
	IONO='_iono.txt'
	NEWMN=.FALSE.
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      TTT(1:4)=TT(1:4)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT
C
      CALL HARMONIC										  !
C
c-	write(*,*) 'Enter ST of input file: '	 !OK
c-	read(*,*) ST							 !OK
	  	YEAR=DD(1:4)
	AYR=YEAR(3:4)
	AMN=DD(5:6)
      DD2=DD(7:8)
	YYMMDD(1:2)=AYR
	YYMMDD(3:4)=AMN
	YYMMDD(5:6)=DD2
	if (DD2.eq.'01') NEWMN=.TRUE.     ! 
C
	CCM=YEAR
	CCM(5:5)=' '
	CCM(6:7)=AMN
	CCM(8:8)=' '
C
c//      infile='/var/www/izmiran/ionosphere/weather/graf/2013/01/stname' !Ljuba 
      infile='d:/web/graf/2013/01/stname'                           !Tamara
c//      infile(42:45)=YEAR												 !Ljuba 
      infile(13:16)=YEAR											 !Tamara
c//	infile(47:48)=AMN												 !Ljuba 
	infile(18:19)=AMN												 !Tamara

c//	OUTFILE1='/var/www/izmiran/ionosphere/weather/graf/2013/styrf.br' !Ljuba 
      OUTFILE1='d:/web/graf/temp/styrf.br'  !Tamara
	outfile1(20:21)=AYR					  !Tamara
	outfile2=outfile1					  
	outfile2(22:22)='m'					  !Tamara
	 outfile3=outfile1					!
	outfile3(22:22)='h'					  !Tamara
c//	infilbr1='/var/www/izmiran/ionosphere/weather/graf/temp/styrf.br' !Ljuba 
	infilbr1='d:/web/graf/temp/styrf.br'  !Tamara
	infilbr1(20:21)=AYR					  !Tamara
 	infilbr2=infilbr1
	infilbr2(22:22)='m'					  !Tamara
      infilbr3=infilbr1
      infilbr3(22:22)='h'					  !Tamara
C ------------------------------------------------------------
		read(AMN,*) rmn					  !
 	imn=int(rmn)        			  !
	      read(AYR,*) ryr					  !
 	iyr=int(ryr)					  !
	z1=iyr/4.0						  !
      jz1=int(z1)*4                     ! 
      IF(jz1.EQ.iyr) THEN				  !
               IM(2)=29				  !
      yds=366.
	  ELSE							  !
                IM(2)=28				  !
	yds=365.
	       ENDIF					  !
C									  !

rem	read(dd1,*) rdy1
rem	idy1=int(rdy1)
   	read(dd2,*) rdy2
 	idy2=int(rdy2)
	call blet2(idy2,dy2)

C Prec. year, prec. month:
	iyr_pre=iyr
	imn_pre=imn-1
	if (imn_pre.le.0) then
	iyr_pre=iyr-1
	imn_pre=12
	endif
	call blet2(iyr_pre,AYR_PRE)
	call blet2(imn_pre,AMN_PRE)
C
	lda2=ndoy(iyr,imn,idy2) ! function to define day-of-year	 !
rem      lda1=ndoy(iyr,imn,idy1) !++++++++++++++++++++++??????
	      lda1=lda2-1
	iyr1=iyr          ! TEMP!!!! for 2013
c?	if (lda1.le.0) then
c?	imn1=imn-1
c?	idy1=im(imn1)       !Correct Final day of Prec. imn1
c?	endif
		call submmdd(lda1,iyr1,imn1,idy1)
	call blet2(idy1,dy1)
	lda0=lda1-1												 !
	iyr0=iyr
	if (lda0.le.0) then
	iyr0=iyr0-1
	imn0=12
	idy0=366+lda0       !Correct Final day of Prec. Year
	endif
		call submmdd(lda0,iyr0,imn0,idy0)
 	call blet2(iyr0,AYR0)
	call blet2(imn0,AMN0)
	call blet2(idy0,ADY0)
C NEW source data files:                       !
	infile1='d:/web/graf/dat1/12/styrmn.txt'      !				   !Tamara
c//      infile1='/var/www/izmiran/ionosphere/weather/graf/dat1/12/styrmn.txt'   !Ljuba NEW

	infile1(18:19)=AYR_PRE			         !				   !Tamara
c//	infile1(42:43)=AYR_PRE                                               !Ljuba	 
					
	infile1(23:24)=AYR_PRE			       !				   !Tamara
c//	infile1(47:48)=AYR_PRE                                                  !Ljuba	 

      infile1(25:26)=AMN_PRE			         !   !Tamara
c//	infile1(49:50)=AMN_PRE                               !Ljuba 
					
	infile2='d:/web/graf/dat5/12/styrmnm.txt'      !				   !Tamara
c//      infile2='/var/www/izmiran/ionosphere/weather/graf/dat5/12/styrmnm.txt'  !Ljuba NEW

	infile2(18:19)=AYR_PRE				         !				   !Tamara
c//	infile2(42:43)=AYR_PRE                                               !Ljuba
					
	infile2(23:24)=AYR_PRE	!										   !Tamara
c//	infile2(47:48)=AYR_PRE                                                  !Ljuba
				         				
      infile2(25:26)=AMN_PRE			         !   !Tamara
c//	infile2(49:50)=AMN_PRE                             !Ljuba 

	infile3='d:/web/graf/dat6/12/styrmnh.txt'      !				   !Tamara
c//      infile3='/var/www/izmiran/ionosphere/weather/graf/dat6/12/styrmnh.txt'  !Ljuba NEW

	infile3(18:19)=AYR_PRE			         !				   !Tamara
c//	infile3(42:43)=AYR_PRE                                               !Ljuba
				
	infile3(23:24)=AYR_PRE			         !				   !Tamara
c//      infile3(47:48)=AYR_PRE                                                 !Ljuba

      infile3(25:26)=AMN_PRE		         !   !Tamara
c//	infile3(49:50)=AMN_PRE                             !Ljuba 


C+ Add extract Rzs from ig_rz.dat file
	do i=1,8
	If (iyr.eq.i+5) then
	rz=rzar(imn,i)    
	exit
	endif
	enddo
C------------------------------------------------------------------
    		infilrem=infile

C START CYCLE ON STATIONS
C
	DO 1500 ista=1,64	
	infile=infilrem				               !  
Ctemp	if ((ista.eq.2).or.(ista.eq.3).or.(ista.eq.53)) then
	if (ista.eq.57) then
	goto 151
	           else
      goto 1500        !<<< temporary one BP and MG stations analysis
	endif
c	if (ista.ne.59) goto 1500        !<<< temporary one MG station analysis

  151	nst=ista
	ST=STS(ista)
C
C
	jf=1
	jh=1
	jt=2
C +++++++++++++++++++++++++++           !
	STNAME(1:6)=YYMMDD
	TITLES=STITLE(ista)
	do k=2,15
	if (titles(k:k).eq.' ') then
	kk=k-1
	exit
	endif
	enddo
	stname(7:)=titles(1:kk)
	kkk=kk+7
	stname(kkk:)=iono
C
c//	OUTFILE1(47:48)=ST						!Ljuba 
	OUTFILE1(18:19)=ST						!Tamara
	infilbr1(18:19)=ST						!Tamara
c//	OUTFILE2(47:48)=ST						!Ljuba 
	OUTFILE2(18:19)=ST						!Tamara
	infilbr2(18:19)=ST						!Tamara
c//	OUTFILE3(47:48)=ST				 !	    !Ljuba 
	OUTFILE3(18:19)=ST						!Tamara
	infilbr3(18:19)=ST						!Tamara
C 
      infile1(21:22)=ST				         !	  !Tamara
c//	infile1(45:46)=ST                                     !Ljuba 
					
	infile2(21:22)=ST				         !	  !Tamara
c//	infile2(45:46)=ST                                     !Ljuba 
				
	infile3(21:22)=ST				         !	  !Tamara
c//	infile3(45:46)=ST                                     !Ljuba 				
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Extract data for preceding month:
C foF2
	nd0=im(imn_pre)
	OPEN(15,file=INFILE1)					   !
	OPEN(12,file=OUTFILE1)					   ! foF2
 	do i=1,4								   !
 	read(15,89) ctext          ! extra lines   !
	enddo									   !
	DO i=1,nd0								   !
 	read(15,89) ctext          ! 
	write(*,89) ctext
	write(12,89) ctext
	enddo
	close(unit=15)
C>		close(unit=12)

C
C m3000
	OPEN(15,file=INFILE2)					   !
	OPEN(13,file=OUTFILE2)					   ! M3F2
 	do i=1,4								   !
 	read(15,89) ctext          ! extra lines   !
	enddo									   !
	DO i=1,nd0								   !
 	read(15,89) ctext          ! 
	write(13,89) ctext
	enddo
	close(unit=15)
C>	close(unit=13)
C
C hmF2
	OPEN(15,file=INFILE3)					   !
	OPEN(14,file=OUTFILE3)					   ! hmF2
 	do i=1,4								   !
 	read(15,89) ctext          ! extra lines   !
	enddo									   !
	DO i=1,nd0								   !
 	read(15,89) ctext          ! 
	write(14,89) ctext
	enddo
	close(unit=15)
C>		close(unit=14)

C
C
C Extract prec, data for current month:
      infile1(25:26)=AMN				         !	!Tamara			
 	infile2(25:26)=AMN  			         !	!Tamara			
 	infile3(25:26)=AMN				         !	!Tamara
c//	infile1(49:50)=AMN                                  !Ljuba 		   NEW*11
c//   infile2(49:50)=AMN                                  !Ljuba 		   NEW*11
c//   infile3(49:50)=AMN                                  !Ljuba 		   NEW*11

	njj=nd0								   ! njj days for two months
	if (idy1.eq.1) goto 1					   !??????????????
C foF2
C
	OPEN(15,file=INFILE1)					   !
	do i=1,4								   !
	read(15,89) ctext          ! extra lines   !
	enddo									   !
	do i=1,idy1-1								   !
		read(15,89) ctext 
	write(*,89) ctext
	write(12,89) ctext
	njj=njj+1
	enddo
		close(unit=15)							   !
C M3000F2
C
	OPEN(15,file=INFILE2)					   !
	do i=1,4								   !
	read(15,89) ctext          ! extra lines   !
	enddo									   !
	do i=1,idy1-1								   !
		read(15,89) ctext 
	write(13,89) ctext
	enddo
		close(unit=15)							   !
C hmF2
C
	OPEN(15,file=INFILE3)					   !
	do i=1,4								   !
	read(15,89) ctext          ! extra lines   !
	enddo									   !
	do i=1,idy1-1								   !
		read(15,89) ctext 
	write(14,89) ctext
	enddo
		close(unit=15)							   !
C----------------------------------------------------------
C -------------------------------------------------------
C Read data for the station:      !
   75 CONTINUE                                                  !
C
C---------------------------------------------------------
C
   89	format(A128)
C
C-----------------------------------------------------------------
   1	continue
C
C=============================================================================
C Add new station data for two current days
C
C New:     21  50
c//	infile(50:)=STNAME					  !Ljuba
      infile(21:)=STNAME					 !Tamara
	iflag=0
C ==========================================================================
C IPG stations
	IF ((st.eq.'mg').or.(st.eq.'rv').or.(st.eq.'sd').or.(st.eq.'tz')
	+.or.(st.eq.'tk')) 
     + then
C>>	infilbr1='d:/web/graf/2013/styrf.br'  !Tamara
	infilrem=infile
	infile=infilbr1 
      infile(13:16)=YEAR				  !Tamara
	iflag=1
	ENDIF
C=======================================================
C SEC stations
	if ((st.eq.'at').or.(st.eq.'bp')) then
	iflag=2
C ADD SEC           ++++++++++++++++++++++++++++++
c-	 if (iflag.eq.2) then
c-	close(unit=12)
c-	close(unit=13)
c-	close(unit=14)
	out1=infilbr1
	out1(13:16)=YEAR				  !Tamara
	out2=out1
	out2(22:22)='m'
	out3=out1
	out3(22:22)='h'


	CALL subsec3(out1,out2,out3)
crem	OPEN(12,file=OUTFILE1)
crem	OPEN(13,file=OUTFILE2)
crem	OPEN(14,file=OUTFILE3)
c-	endif 
C>>	infilbr1='d:/web/graf/temp/styrf.br'  !Tamara
	infilrem=infile
	infile=infilbr1 
      infile(13:16)=YEAR				  !Tamara
	endif !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C ===================================
1077	kfulf=0
	kfulm=0
C
	DO 77 lda=lda1,lda2				   ! day-to-day cycle	 !
	jj=lda-lda1+1
	call submmdd(lda,iyr,imn,jd)
	call blet2(iyr,BYR)
	call blet2(imn,BMN)
	call blet2(jd,BDY)
C define day for comparison:
	DDD=BDY
C
	CCF='/ '

	INFILE(22:22)='f' 
     	OPEN(11,FILE=INFILE)                        !
C
C IPG:
crem	IF (iflag.eq.1) THEN
		IF (iflag.gt.0) THEN	  !IPG and SEC

	do k=0,23
  	IF2(JD,k)=0
      cf2(k)='  '		
	IH2(JD,k)=0
      ch2(k)='  '					 !
 	IM3(JD,k)=0
	cm2(k)='  '
	enddo
  999	read(11,87,end=76) CYR,CMN,CDY,(IF2(JD,k),cf2(k),k=0,23)
	if ((cyr.eq.byr).and.(cmn.eq.bmn).and.(cdy.eq.bdy)) then
	goto 76
	   else
	goto 999
	endif

	ENDIF
C The following command are avoided ( former from SEC !)

	CONTINUE	!***********************************************************
c	GOTO 76                                                     !!!!!!!!!!!!!!!!!
C******************************************************************88888
   76	close (unit=11)
	if (iflag.eq.1) goto 271      !Avoid reading M3 and hm for IPG files
	 infile(22:22)='m'
	OPEN(11,FILE=INFILE)
 1999	read(11,87,end=998) CYR,CMN,CDY,(IM3(JD,k),cm2(k),k=0,23)
	if ((cyr.eq.byr).and.(cmn.eq.bmn).and.(cdy.eq.bdy)) then

	goto 998
	   else
	goto 1999
	endif
  998	close (unit=11)

C reading hm
C
	 infile(22:22)='m'
	OPEN(11,FILE=INFILE)
 1998	read(11,87,end=997) CYR,CMN,CDY,(Ih2(JD,k),ch2(k),k=0,23)
	if ((cyr.eq.byr).and.(cmn.eq.bmn).and.(cdy.eq.bdy)) then

	goto 997
	   else
	goto 1998
	endif
  997	close (unit=11)

C
  271	continue

C++++++++++++++++++++++++++++++++++++++++++++++++++
      		close(unit=12)
			close(unit=13)
			close(unit=14)
C foF2 from .br file
      infile=infilbr1
cback	infile(24:26)='br '

     	OPEN(11,FILE=INFILE,ACTION='READ')                        !
	do k=0,23
	ictf(8,k)=0
	cf2(k)=CCF
	enddo
  161	read(11,1000,END=1003) CYR,CMN,ICDY,(ictf(8,k),cf2(k),k=0,23)     !
crem  161	read(11,1000,END=162) CYR,CMN,ICDY,(ictf(8,k),cf2(k),k=0,23)     !
	call blet2(icdy,CDY)
	goto 1002
 1003	cyr=byr
      cmn=bmn
	cdy=bdy
	goto 1001
 1002 if ((cmn.eq.BMN).and.(cdy.eq.BDY)) goto 1001
C Keep 7 last lines:
CREM	if (icdy.ge.jd-1) goto 1001
CREM	if ((cmn.eq.BMN).and.(icdy.ge.jd-1)) goto 1001
	if ((cmn.eq.BMN).and.(icdy.ge.jd)) goto 1001
	do k=2,8
	do j=0,23
	ictf(k-1,j)=ictf(k,j)
	enddo
	enddo

 1001 if ((cmn.eq.BMN).and.(cdy.eq.BDY)) then  !>>>>>>
	if (iflag.eq.1) then     !IPG
	do k=0,23
	ictf(8,k)=if2(jd,k)
	enddo
	goto 162
	endif

	do k=0,23
crem      if (cf2(k).eq.CCF) then 
crem	ictf(8,k)=0
crem 	cf2(k)='  '
crem	endif
	if2(jd,k)=ictf(8,k)
	enddo
	goto 162
	else                                     !>>>>>>
	goto 161
	endif									 !>>>>>>
  162	close(unit=11)

C	M3000 from .br file
      infile=infilbr2
c,,	infile(24:26)='br '
C
     	OPEN(11,FILE=INFILE,ACTION='READ')                        !
	do k=0,23
	ictm(8,k)=0
	cm2(k)=CCF
	enddo
  163	read(11,1000,END=2003) CYR,CMN,ICDY,(ictm(8,k),cm2(k),k=0,23)     !
CREM  163	read(11,1000,END=164) CYR,CMN,ICDY,(ictm(8,k),cm2(k),k=0,23)     !
      call blet2(icdy,CDY)
	goto 2002
 2003	cyr=byr
      cmn=bmn
	cdy=bdy
	goto 2001
 2002     if ((cmn.eq.BMN).and.(cdy.eq.BDY)) goto 2001
C Keep 7 last lines:
CREM	if (icdy.ge.jd-1) goto 2001
crem      if ((cmn.eq.BMN).and.(icdy.ge.jd-1)) goto 2001
	if ((cmn.eq.BMN).and.(icdy.ge.jd)) goto 2001
	do k=2,8
	do j=0,23
	ictm(k-1,j)=ictm(k,j)
	enddo
	enddo
 2001	if ((cmn.eq.BMN).and.(cdy.eq.BDY)) then			!>>>>>>
	if (iflag.eq.1) then     !IPG
	do k=0,23
	ictm(8,k)=0
	enddo
	goto 164
	endif

	do k=0,23
	if (cm2(k).eq.CCF) then
	ictm(8,k)=0 
	cm2(k)='  '
	endif
	im3(jd,k)=ictm(8,k)
		enddo
	goto 164
	else									 !>>>>>>
	goto 163
	endif									   !>>>>>>
  164	close(unit=11)

C	hmF2 from .br file
      infile=infilbr3
c>>	infile(24:26)='br '
C
     	OPEN(11,FILE=INFILE,ACTION='READ')                        !
	do k=0,23
	icth(8,k)=0
	ch2(k)=CCF
	enddo

  165	read(11,1000,END=3003) CYR,CMN,ICDY,(icth(8,k),ch2(k),k=0,23)     !
CREM  165	read(11,1000,END=166) CYR,CMN,ICDY,(icth(8,k),ch2(k),k=0,23)     !
      call blet2(icdy,CDY)
	goto 3002
 3003	cyr=byr
      cmn=bmn
	cdy=bdy
	goto 3001
 3002     if ((cmn.eq.BMN).and.(cdy.eq.BDY)) goto 3001
C Keep 7 last lines:
Crem	if (icdy.ge.jd-1) goto 3001
CREM      if ((cmn.eq.BMN).and.(icdy.ge.jd-1)) goto 3001
	if ((cmn.eq.BMN).and.(icdy.ge.jd)) goto 3001
	do k=2,8
	do j=0,23
	icth(k-1,j)=icth(k,j)
	enddo
	enddo
 3001	if ((cmn.eq.BMN).and.(cdy.eq.BDY)) then			!>>>>>>
	if (iflag.eq.1) then     !IPG
	do k=0,23
	icth(8,k)=0
	enddo
	goto 166
		endif
	do k=0,23
crem	if (ch2(k).eq.CCF) then 
crem      icth(8,k)=0
crem	ch2(k)='  '
crem	endif
	ih2(jd,k)=icth(8,k)
	 enddo
     	goto 166
	else
	goto 165
	endif
  166	close(unit=11)

C ========================================================
  176	continue

   71	continue
C++++++++++++++++++++++++++++++++++++++++++++++++++++
C Add production of hmF2 using Shimazaki formula from M3000F2
	DO k=0,23
	CCF='  '
	if ((ih2(jd,k).eq.0).and.(im3(jd,k).gt.0)) then
	ih2(jd,k)=nint(149000./im3(jd,k)-176.)
	ch2(k)=CCF
	endif
	enddo
C
C Check and forecast missed foF2 data
	do ik=0,23
	xdat(5,ik)=0.
	      do kk=1,4
	xdat(kk,ik)=float(ictf(kk+3,ik))	 !foF2 from lines 4...7
	enddo
	      enddo

C Furie extrapolation of foF2
	call subfur4a(xdat)

C replace missed data by Furie prediction:
	do k=0,23
c>>	cf2(k)='  '
CREM	if ((if2(jd,k).eq.0).or.(cf2(k).eq.'/ ')) then
	if (if2(jd,k).eq.0) then
	if2(jd,k)=nint(xdat(5,k))
	cf2(k)='/ '
	endif
	enddo

C Produce 7-prec.days median of foF2
	do k=0,23
	do j=1,7
	ydat(j,k)=float(ictf(j,k))/10.
	enddo
	ydat(8,k)=0.
	enddo
	call sumedian(7,ydat,fmed)
C
	do k=0,23
	DO kk=1,7
	ictf(kk,k)=ictf(kk+1,k)  !move data up one line
	enddo
	ictf(8,k)=if2(jd,k)
	ENDDO
C     
C Check and forecast missed hmF2 data

C  hmF2	  by subdlogh
	do k=0,23
	do j=1,7
	ydat(j,k)=float(icth(j,k))
	enddo
c??	ydat(8,k)=0.
	enddo

C Produce 7-prec.days median of hmF2
	call sumedian(7,ydat,hmed)

	amlat=xmlat(ista) ! mag. latitude
C+ TLG Day-of-year reduced to 360.=> sday=season_day
	sday=float(lda)/yds*360.			 ! north hemisphere
      IF(amlat.GT.0.0) GOTO 55
TLG : sday for the sothern hemisphere:
	sday=sday+180.						! south hemisphere
	if (sday.gt.360.) sday=sday-360.	! south hemisphere
  55	DO k=0,23
	fof2=float(if2(jd,k))/10.
	dlogne=2.*(alog10(fof2)-alog10(fmed(k)))
	CALL SUBDLOGH(dlogne,amlat,sday,rz,dlgh)
		rathhm=10.**dlgh !new
 	if (rathhm.lt.0.8) rathhm=0.8
	HMF2=hmed(k)*rathhm !new
	ihmf2=nint(hmf2)
	if (ih2(jd,k).eq.0) then
C replace missed data by hmF2 prediction:
	ih2(jd,k)=ihmf2
	ch2(k)='/ '
	endif

cxx	icth(8,k)=nint(hmf2)
	 ENDDO
c>>	do k=0,23
c>>	ch2(k)='  '
CREM	if ((ih2(jd,k).eq.0).or.(ch2(k).eq.'/ ')) then
c>>	if (ih2(jd,k).eq.0) then
c>>	ih2(jd,k)=icth(8,k)
c>>	ch2(k)='/ '
c>>	endif
c>>	enddo
	do k=0,23
	DO kk=1,7
	icth(kk,k)=icth(kk+1,k)  !move data up one line
	enddo
	icth(8,k)=ih2(jd,k)
	ENDDO
C     
      OPEN(18,file=INFILE1,ACTION='READ')
	ncnt=0
	do nn=1,jd+3
 	read(18,89,END=331) atext(nn)
	ncnt=ncnt+1
	enddo
  331	close(unit=18)
  332	format('Date of issue: ',A4,'/',A2,'/',A2,' Time:',A4)
   	OPEN(19,file=INFILE1)
 	OPEN(12,file=OUTFILE1,access='APPEND')
	do nn=1,jd+4
	text=atext(nn)
	XYR=text(1:2)
	XMN=text(3:4)
	XDY=text(5:6)
	if(((XYR.eq.BYR).and.(XMN.eq.BMN).and.(XDY.eq.BDY)).or.
	+(nn.eq.jd+4)) then 
	write(*,87) BYR,BMN,BDY,(IF2(JD,k),cf2(k),k=0,23)
	write(19,87) BYR,BMN,BDY,(IF2(JD,k),cf2(k),k=0,23)
	write(12,87) BYR,BMN,BDY,(IF2(JD,k),cf2(k),k=0,23)
	else
	if (nn.eq.2) then
			WRITE(19,332) year,amn,dd2,TTT
	else
	write(19,89) text
	endif
	ENDIF
	enddo
	close(unit=19)
	close(unit=12)
      OPEN(18,file=INFILE2,ACTION='READ')
	ncnt=0
	do nn=1,jd+3
 	read(18,89,END=333) atext(nn)
	ncnt=ncnt+1
	enddo
  333	close(unit=18)
 	OPEN(13,file=OUTFILE2,access='APPEND')
   	OPEN(19,file=INFILE2)
	do nn=1,jd+4
	text=atext(nn)
	XYR=text(1:2)
	XMN=text(3:4)
	XDY=text(5:6)
	if(((XYR.eq.BYR).and.(XMN.eq.BMN).and.(XDY.eq.BDY)).or.
	+(nn.eq.jd+4)) then 
 	write(*,87) BYR,BMN,BDY,(IM3(JD,k),cm2(k),k=0,23)  !
	write(19,87) BYR,BMN,BDY,(IM3(JD,k),cm2(k),k=0,23)	!
	write(13,87) BYR,BMN,BDY,(IM3(JD,k),cm2(k),k=0,23)	!
	else
	if (nn.eq.2) then
			WRITE(19,332) year,amn,dd2,TTT
	else
	write(19,89) text
	endif
	ENDIF
	enddo
	close(unit=19)
	close(unit=13)
      OPEN(18,file=INFILE3,ACTION='READ')
	ncnt=0
	do nn=1,jd+3
 	read(18,89,END=334) atext(nn)
	ncnt=ncnt+1
	enddo
  334	close(unit=18)
 	OPEN(14,file=OUTFILE3,access='APPEND')		 !
   	OPEN(19,file=INFILE3)
	do nn=1,jd+4
	text=atext(nn)
	XYR=text(1:2)
	XMN=text(3:4)
	XDY=text(5:6)
	if(((XYR.eq.BYR).and.(XMN.eq.BMN).and.(XDY.eq.BDY)).or.
	+(nn.eq.jd+4)) then 
 	write(*,87) BYR,BMN,BDY,(IH2(JD,k),ch2(k),k=0,23)  !
	write(19,87) BYR,BMN,BDY,(IH2(JD,k),ch2(k),k=0,23)	!
	write(14,87) BYR,BMN,BDY,(IH2(JD,k),ch2(k),k=0,23)	!
	else
	if (nn.eq.2) then
			WRITE(19,332) year,amn,dd2,TTT
	else
	write(19,89) text
	endif
	ENDIF
	enddo
	close(unit=19)
	close(unit=14)
C// 	write(14,87) BYR,BMN,BDY,(IH2(JD,k),ch2(k),k=0,23)  !
C//	write(*,87) BYR,BMN,BDY,(IH2(JD,k),ch2(k),k=0,23)	!
C  Move data up by 1 day:++++++++++++++++++++++++++++++===========
	DO kk=1,7
	do k=0,23
	ictm(kk,k)=ictm(kk+1,k)  !move data up one line
	enddo
	ENDDO
	do k=0,23
	ictf(8,k)=if2(jd,k)
	ictm(8,k)=im3(jd,k)
	icth(8,k)=ih2(jd,k)
	enddo
C
C +output med
	outmedf=outfile1
	outmedf(24:26)='med'
	outmedh=outfile3
	outmedh(24:26)='med'
	  OPEN(16,file=OUTmedf,access='APPEND')
	OPEN(17,file=OUTmedh,access='APPEND')
	do k=0,23
	imedf(k)=nint(fmed(k)*10)
	imedh(k)=nint(hmed(k))
	enddo
	write(*,88) BYR,BMN,BDY,(imedf(k),k=0,23)
	write(16,88) BYR,BMN,BDY,(imedf(k),k=0,23)
	write(*,88) BYR,BMN,BDY,(imedh(k),k=0,23)
	write(17,88) BYR,BMN,BDY,(imedh(k),k=0,23)
	close(unit=16)
	close(unit=17)
	do k=0,23
	cf2(k)='  '
	cm2(k)='  '
	ch2(k)='  '
	enddo
   77 continue                 ! go to the next day
   88	format(3A2,2X,24(I3,2X))					!
   87	format(3A2,2X,24(I3,A2))					!
   86	format(3A2,1X,24(I4,A1))					!
 1000	format(2A2,I2,2X,24(I3,A2))					!
C End of daily cycle ===============
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2   CONTINUE
c	 CLOSE (unit=12)
c			CLOSE (unit=13)
c	CLOSE (unit=14)							  !
C Add writing 2 new lines to graf/dat1/13/   DAT5/13/   DAT6/13/,
C=========================================================================
C Add writing 2 new lines to graf/dat1/13/   DAT5/13/   DAT6/13/,



 1500	CONTINUE      ! End cycle on SEC stations
	pause ' '
	STOP
	END
C
      subroutine blet2(ilet,alet2)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
CLjuba	a2='00'
	alet2='00'             !
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
C
	subroutine harmonic
C ............................................................Sep. 2012
C Arrange Furie coefficients
	DIMENSION
	+FU1(24),FU2(24),FUA(5,24),FUB(5,24),COEFA(74),COEFB(74)
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie
C
	DATA COEFA/
     &.2588190, .5, .7071068, .8660254, .9659258,1.0,.9659258,.8660254
     &, .7071067, .5, .2588190, .0,-.2588191,-.5,-.7071068,-.8660254,
     &-.9659259,-1.0,-.9659258,-.8660253,-.7071066,-.5,-.2588189, .0
     &,.5,.8660254,1.0,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5
     &,.0, .7071068, 1.0, .7071067, .0,-.7071068,-1.0,-.7071066, .0      
     &, .8660254, .8660254, .0,-.8660254,-.8660253, .0
     &,.9659258,.5,-.7071068,-.8660253,.2588192,1.0,.2588188,-.8660256
     &,-.7071065, .5, .9659257,.0,-.9659259,-.5, .7071072,.8660251
     &,-.2588196,-1.0,-.2588184, .8660257, .7071062,-.5,-.9659256, .0/
	DATA COEFB/
     &.9659258, .8660254, .7071068, .5, .2588190, .0,-.2588191,-.5
     &,-.7071068,-.8660254,-.9659259,-1.0,-.9659258,-.8660253,-.7071067
     &,-.5,-.2588189,.0, .2588192,.5,.7071069, .8660255, .9659259, 1.0     
     &,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5,.0,.5,.8660255
     &,1.0, .7071068, .0,-.7071068,-1.0,-.7071067, .0, .7071069, 1.0
     &, .5,-.5,-1.0,-.5, .5, 1.0
     &, .2588190,-.8660254,-.7071067, .5, .9659258, .0,-.9659259,-.5
     &,.7071070,.8660252,-.2588194,-1.0,-.2588186,.8660257,.7071064,-.5
     &,-.9659257, .0, .9659260, .5,-.7071073,-.8660250, .2588198, 1.0/
C
C  Re-arrange coefficients for Ai, Bi:
	DO JCASE=1,5
	select case (jcase)
	case (1)
    	do i=1,24
    	fu1(i)=coefa(i)
	fu2(i)=coefb(i)
	enddo
	goto 6
	case (2)
    	do i=1,12 
      fu1(i)=coefa(i+24)
      fu1(i+12)=fu1(i)
	fu2(i)=coefb(i+24)
	fu2(i+12)=fu2(i)
	enddo
	goto 6
	case (3)
    	do i=1,8 
    	fu1(i)=coefa(i+36)
	fu1(i+8)=fu1(i)
	fu1(i+16)=fu1(i)
	fu2(i)=coefb(i+36)
	fu2(i+8)=fu2(i)
	fu2(i+16)=fu2(i)
	enddo
	goto 6
	case (4)
    	do i=1,6 
    	fu1(i)=coefa(i+44)
	fu1(i+6)=fu1(i)
	fu1(i+12)=fu1(i)
	fu1(i+18)=fu1(i)
	fu2(i)=coefb(i+44)
	fu2(i+6)=fu2(i)
	fu2(i+12)=fu2(i)
	fu2(i+18)=fu2(i)
	enddo
	goto 6
	case (5)
    	do i=1,24
    	fu1(i)=coefa(i+50)
	fu2(i)=coefb(i+50)
	enddo
	goto 6
	end select
C
    6		do nn=1,24
      FUA(jcase,nn)=fu1(nn)
	FUB(jcase,nn)=fu2(nn)
	enddo
	ENDDO
      RETURN
	END
C ===============================================================
      integer function ndoy(iyr,imn,idy)
C To define day-of-year
C
	       DIMENSION IM(12)
	integer*2 iyr,imn,idy
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	z1=iyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+idy	
	END FUNCTION
C ===============================================================
C
      subroutine submmdd(lda,iyr,imn,idy)
C To define imn & idy using iyr & lda=day-of-year
C
	       DIMENSION IM(0:12)
	integer*2 iyr,imn,idy,nyr,ii
	DATA IM/31,31,28,31,30,31,30,31,31,30,31,30,31/
	nyr=iyr
	imn=0
	idy=0
	z1=nyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.nyr) THEN
               IM(2)=29
	ndyr=366
        ELSE
                IM(2)=28
	ndyr=365
	       ENDIF
C Day-of-year = LDA
c//	write(*,*) lda
c//	pause ' '
C Define imn & idy
C NEW++++++++++++++++++++
	mosum=0
         do 1234 ii=1,12
	ndsum=mosum
	mosum=mosum+im(ii)
	imn=ii
	if (lda.le.mosum) then
	idy=lda-ndsum
	 goto 33
	exit
	endif
1234    continue
 33     continue
	RETURN
	END 
C ===============================================================
