	subroutine subsao(ADY)
C
C............................................................June 2013
C Use this subroutine instead of PROGRAM convNO2.for
C!                                                           Jan 2013
C!    Extract foF2, hmF2, M3000 from .sao file
C!    Include subroutines: dayyesr, sublet2
C!                                                           MAR 2013
C!    Include subroutines: dayyear, sublet2
C
C  TLG......................................................April 2010
C
c "CONVNO" EXTRACT foF2 & M3000F2 & hmF2 FROM DAILY-HOURLY FILE, NO
C 
	DIMENSION im(12)
	INTEGER*2 jyr,jmn,jdy,COUNTER,jjut
	+,jdy_pre,jmn_pre                           !C! new parameters
	CHARACTER*128 infile,outfile,TITLE1,TITLE2
     +,m_file,f_file,h_file
 	CHARACTER*4 YEAR,YEAR_pre
	CHARACTER*2 AYR,AMN,AMN_pre,ST,DY1,DY2,DDD,ADY(0:31),TT,AUT,
     *CYR,CMN,CDY,STS_IN(12),STS_OUT(12),STS_NAME ! ,     DATA STS,    -  STS_IN(12)  STS_OUT(11)
	*,dd1,dd2,DY22
	CHARACTER*1 fm						 
	CHARACTER*5 DATF(0:366,24),DATM(0:366,24),DATH(0:366,24),FOF2,BBB
	+,hmf2,x3f2                     
	+,NUM_STS(12) ! ,     DATA STS,    -  NUM_STS(12)
	CHARACTER*3 DOY
	CHARACTER*5 FINP,XM3,HF2
       CHARACTER*128 m_data
	CHARACTER*30 STNAME
	COMMON /BL1/ST,YEAR,AYR,AMN,DY1,DY2,DD1,DD2,ID1,ID2,JF,JH,JT,DY22
 	+,STNAME
C
	DATA STS_IN/'NO','YK','MA','SJ','BP','CQ','HA','GZ','ML','AU'
	+,'CR','CL'/         ! Our Directory name
      DATA STS_OUT/'no','yk','mo','sj','bp','cq','ha','gu','ml','au'
	+,'cr','cl'/
      DATA NUM_STS/'NO369','YA462','MA155','SJJ18','BP440','09429'
	+,'HA419','GU421','ML449','AU930','GH64L','CL424'/  ! Source station code
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
crem	DATA ADY/32*'00'/

C	DAT(0:366,24)
	do n=0,366
	do k=1,24
	datf(n,k)=' 00  '
	datm(n,k)='000  '
	dath(n,k)='000  '
	enddo
	enddo
c--	st='NO'
C++
crem	write(*,*) 'enter ST='
crem	read(*,*) st
	do ist=1,12
	if (sts_out(ist).eq.st) exit
	enddo

C TLG+ Temporary:
crem	write(*,*) 'enter YEAR='
crem	read(*,*) YEAR
crem	YEAR='2013'		!temp +
crem	write(*,*) 'enter AMN='
crem	read(*,*) AMN
crem	AMN='01'			!temp +
crem	write(*,*) 'enter DY1='
crem	read(*,*) dy1
ctemp	dy1='16'			!temp +
crem	write(*,*) 'enter DY2='
crem	read(*,*) dy2
c temp	dy2='17'			!temp +
crem	YEAR_pre='2013'		!temp +
      YEAR_pre=YEAR	   !ADD
	AMN_pre='01'		!temp +
C ==========================================================

C Next line: specify YEAR from current date:
       AYR=YEAR(3:4)
C Next line: specify MONTH from current date:
	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
	jmn=int(rmn)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C!
C! Add check content of <datefile> for preceding month & day:
	 read(dy1,*) rdy1     !C! day in new month
	jdy=int(rdy1)		  !C! day in new month
	ndoy1=0				  !C! day in new month
	 read(dy2,*) rdy2     !C! day in new month
c--	jdy=int(rdy2)		  !C! day in new month
	ndoy1=ndoy(jyr,jmn,jdy)
	jdy_pre=0			   !C! prec. day 
	jmn_pre=0			   !C! month for prec. day
	ndoy0=ndoy1-1		   !C! prec. day of year
c//	call dayyear(jyr,jmn_pre,jdy_pre,ndoy0) !C! produce mon & day for preceding day
	jmn_pre=jmn  ! TEMP
	jdy_pre=jdy ! TEMP
	call blet2(jmn_pre,AMN_pre)    !C! produce CHARACTER AMN_pre     
	call blet2(jdy_pre,dy1)    !C! produce CHARACTER <dy1>
C End of Check for preceding day	     
C! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      WRITE(*,*)YEAR,AMN,dy2,YEAR_pre,AMN_pre,dy1   ! this line is moved here C!

C Next line: get YEAR,AMN,dy2,YEAR_pre,AMN_pre,dy1 from file "date"

c       datefile='/var/www/izmiran/ionosphere/weather/graf/date' ! Ljuba
   50	FORMAT(A4,1x,A2,1x,A2,1x,A4,1x,A2,1x,A2,A10)			   ! Ljuba
c       OPEN(13,FILE=datefile,STATUS='OLD')					   ! Ljuba
c       read (13,50)YEAR,AMN,dy2,YEAR_pre,AMN_pre,dy1			   ! Ljuba
c       close(unit=13)											   ! Ljuba
C ==========================================================

C     3-    GM111m.br, IR11m.br  YK11m.br NO10m.br
c 	DATA STS_OUT/'GM','IR','NO','YK'/ = GM111m.br IR11m.br  YK11m.br  NO10m.br
C ==============================================================
c     
CREM      do i=1,9   !   ! ,     DATA STS,    - 9!!!
      do i=ist,ist
      STS_NAME=STS_OUT(i)
      write(*,*) ' STS_NAME= ', STS_NAME, STS_OUT(i), i
c
  333 FORMAT(a128)
      count=0
c      m_file='/var/www/izmiran/ionosphere/weather/graf/2010/NO10m.br' !Ljuba
      m_file='d:/web/graf/2012/no10m.br' 								!Tamara
c      m_file(42:45)=YEAR        										 !Ljuba
c      m_file(47:48)=STS_NAME  										 !Ljuba
c      m_file(49:50)=AYR  												 !Ljuba
      m_file(13:16)=YEAR        										 !Tamara
      m_file(18:19)=STS_NAME  										 !Tamara
      m_file(20:21)=AYR  												 !Tamara
      OPEN(33,FILE=m_file,STATUS='OLD')
   55 READ(33, 333, END=44) m_data 
	CYR=m_data(1:2)
	CMN=m_data(3:4)
	CDY=m_data(5:6)
	if ((cyr.eq.ayr).and.(cmn.eq.amn_pre).and.(cdy.eq.dy1)) then  
	goto 44
	                  else
         count=count+1
      GOTO 55
      CONTINUE
                  	endif
   44 m_strings = count
      REWIND (33)
      count=0
      do while (count.lt.m_strings)
         READ(33, 333, END=444) m_data 
         count=count+1
      enddo
  444 print*,'YES!'
      ENDFILE 33
      close(UNIT=33)
CCC
      count=0
c      f_file='/var/www/izmiran/ionosphere/weather/graf/2010/NO10f.br'	  !Ljuba
c      f_file(42:45)=YEAR  											  !Ljuba
c      f_file(47:48)=STS_NAME 											  !Ljuba
c      f_file(49:50)=AYR  												  !Ljuba
      f_file='d:/web/graf/2012/no10f.br'	  !Tamara
      f_file(13:16)=YEAR  											  !Tamara
      f_file(18:19)=STS_NAME 											  !Tamara
      f_file(20:21)=AYR  												  !Tamara

      OPEN(88,FILE=f_file,STATUS='OLD')
  255 READ(88, 333, END=244) m_data 
	CYR=m_data(1:2)
	CMN=m_data(3:4)
	CDY=m_data(5:6)
	if ((cyr.eq.ayr).and.(cmn.eq.amn_pre).and.(cdy.eq.dy1)) then	
	goto 244
	                  else
         count=count+1
      GOTO 255
      CONTINUE
                  	endif
  244 f_strings = count
      REWIND (88)
      count=0
      do while (count.lt.f_strings)
         READ(88, 333, END=248) m_data 
         count=count+1
      enddo
  248 print*,'YES!'
      ENDFILE 88
      close(UNIT=88)
C TLG ADD!
CCC
      count=0
c      f_file='/var/www/izmiran/ionosphere/weather/graf/2010/NO10h.br'   !Ljuba
c      h_file(42:45)=YEAR 												   !Ljuba
c      h_file(47:48)=STS_NAME  										   !Ljuba
c      h_file(49:50)=AYR  												   !Ljuba
      h_file='d:/web/graf/2012/no10h.br'								  !Tamara
      h_file(13:16)=YEAR  											  !Tamara
      h_file(18:19)=STS_NAME 											  !Tamara
      h_file(20:21)=AYR  												  !Tamara

      OPEN(55,FILE=h_file,STATUS='OLD')
  355 READ(55, 333, END=344) m_data 
	CYR=m_data(1:2)
	CMN=m_data(3:4)
	CDY=m_data(5:6)
	if ((cyr.eq.ayr).and.(cmn.eq.amn_pre).and.(cdy.eq.dy1)) then  
	goto 344
	                  else
         count=count+1
      GOTO 355
      CONTINUE
                  	endif
  344 h_strings = count
      REWIND (55)
      count=0
      do while (count.lt.h_strings)
         READ(55, 333, END=348) m_data 
         count=count+1
      enddo
  348 print*,'YES!'
      ENDFILE 55
      close(UNIT=55)
      enddo
C=============================================================== 
C     3-    GM11m.br, IR11m.br  YK11m.br NO11m.br jj11m.br
C ==============================================================
c
C=============================================================== 
C     GM11m.br, IR11m.br  YK11m.br NO10m.br jj11m.br
C ==============================================================
c
c      DO COUNTER=1,6  ! ,  - !!!!
      DO COUNTER=ist,ist! ,  - !!!!
c      WRITE(*,*)' COUNTER=', COUNTER
c
c
c
c
C        Double letters cycle + letters 'f', 'm', 'h':
      fm='f'
	iflag=0
C ==========================================================

C Next line : specify DAY1 and DAY2 from current dates:
C	       WRITE(*,*)' ENTER START-DY1,END-DY2:'
C	       READ(*,*) DY1,DY2
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c	dy1='09'
c	dy2='12'
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	read(dy1,*) rdy1
	read(dy2,*) rdy2
 	idy1=int(rdy1)
	idy2=int(rdy2)
	idd=idy1
C
      STS_NAME=STS_OUT(COUNTER)
c      print*,'STS_OUT(COUNTER)=', STS_OUT(COUNTER)

c+	 Next lines = specify path and name of Output file:
c=
c      outfile='/var/www/izmiran/ionosphere/weather/graf/2012/NO12f.br' !Ljuba
c      outfile(42:45)=YEAR  											 !Ljuba
c      outfile(47:48)=STS_NAME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!Ljuba
c      outfile(49:50)=AYR  												 !Ljuba
CREM      outfile='d:/web/graf/2012/no12f.br'                             !Tamara
      outfile='d:/web/graf/temp/no12f.br'                             !Tamara
CREM      outfile(13:16)=YEAR  											 !Tamara
      outfile(18:19)=STS_NAME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!Tamara
      outfile(20:21)=AYR  											 !Tamara
C ==========================================================
101	  continue

C ==========================================================
   1	do 77 j=idy1,idy2               ! cycle day-by-day
	jdy=j
	jj=j-idy1+1
	call blet2(jdy,DDD)
	ADY(jj)=ddd
C
C Calculate day-of-year:
   17	FORMAT(1X,A3)
	lday=ndoy(jyr,jmn,jdy) ! function to define day-of-year
	call blet3(lday,DOY)
	write(*,17) doy

1111	DO 1110 jut=1,24             ! Daily cycle
	title1=' '
	ut=float(jut-1)
	jjut=jut-1
	call blet2(jjut,AUT)

C  
c
      STS_NAME=STS_IN(COUNTER)
c      print*,'STS_IN(COUNTER)=', STS_IN(COUNTER)

c      infile='/var/www/izmiran/ionosphere/weather/graf/NO/'  !Ljuba
c      infile(42:43)=STS_NAME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!Ljuba
c      infile(45:46)=STS_NAME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!Ljuba
c      infile(47:49)=NUM_STS(COUNTER) 						   !Ljuba
c      infile(50:)='_2011035040000.SAO' 					   !Ljuba
      infile='d:/web/graf/NO/'                               !Tamara
      infile(13:14)=STS_NAME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!Tamara
c-      infile(16:17)=STS_NAME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!Tamara
      infile(16:20)=NUM_STS(COUNTER) 						   !Tamara NEW!!!!!!!
      infile(21:)='_2013035040000.SAO' 					   !Tamara
	if ((ist.ge.5).and.(ist.lt.10)) infile(34:34)='1'        !NEW!!!!!
	if (ist.eq.4) infile(31:34)='0400'        !NEW!!!!!
	if (ist.eq.10) infile(31:34)='0005'        !NEW!!!!!

c      infile(45:)='NO369_2011035040000.SAO'                 !Ljuba???????
c	infile(51:54)=YEAR								  !Ljuba
c	infile(55:57)=DOY								  !Ljuba
c	infile(58:59)=AUT                                 !Ljuba
	infile(22:25)=YEAR								  !Tamara
	infile(26:28)=DOY								  !Tamara
	infile(29:30)=AUT                                 !Tamara

c      WRITE(*,*)' INFILE:',infile !   !!!
C ==========================================================

    	OPEN(11,FILE=INFILE,err=3)
	read (11,*,err=3,end=10) title1
	goto 9
   10	continue
	 TT=title1(1:2)
	if (TT.eq.' ') then
	goto 3
C?	else
C?	goto 442
	endif
   9	continue
C Change input for SAO format ===============
	nn=15
	if (ist.ge.10) nn=5
	do k=1,nn
	read (11,*,err=3,end=2) title2  ! extra lines
	if (title2(3:6).eq.YEAR) exit
	enddo
C
	if ((ist.lt.5).or.(ist.ge.10)) then
	read (11,106,err=3,end=2) finp,xm3
	if (xm3.eq.'9.000') xm3=' 000 '
	read (11,*,err=3,end=2) title2  ! extra lines TLG
	read (11,306,err=3,end=2) hf2
	continue
	               else
	read (11,105) finp			! China stations
	xm3=' 000 '
	hf2='000  '
	endif

  106 FORMAT(2X,A5,12X,A5)
  105 FORMAT(1X,A5)
  306 FORMAT(9X,A5)
C
C Add control of letters in input data:                  
	call replets(finp,bbb)							    
	finp=bbb										   
	call replets(xm3,bbb)							   
	if (bbb.eq.' 000 ') bbb='0000 '                     
      xm3=bbb											   
	call replets(hf2,bbb)							    
      hf2=bbb											    
C

	 foF2=' 00  '
	if (finp(1:2).eq.'99') then 
c	finp=foF2
	finp=' 000 '
c	xm3=foF2
      xm3='0000 '
	endif
	if (hf2(1:3).eq.'999') then
	hf2='0000 '
	endif
C 

C
CREM	if (fm.eq.'f') then
	foF2(1:2)=finp(1:2)
	foF2(3:3)=finp(4:4)
CREM	endif
CREM	if (fm.eq.'m') then
	x3F2(2:2)=xm3(1:1)
	x3F2(3:4)=xm3(3:4)
CREM	               endif
CREM	if (fm.eq.'h') then
	hmF2(2:4)=hf2(1:3)
CREM	endif
C ========================================
   11	continue
  440 CLOSE (unit=11)
  107	 datf(jj,jut)=fof2
      datm(jj,jut)=x3f2
	dath(jj,jut)=hmf2
	
1110	continue           ! End of daily cycle

  77  continue         ! end cycle day-to-day

c
c
C ==========================================================
c	  outfile(51:51)=fm                                              !Ljuba
crem	outfile(22:22)='m'												!Tamara
CREM	OPEN(12,FILE=OUTFILE,ACCESS='APPEND')
	DO J=1,JJ
crem	if (fm.eq.'m') then
		write(13,181) ayr,amn,ady(j),(datm(j,k),k=1,24)
 	write(*,181) ayr,amn,ady(j),(datm(j,k),k=1,24)
	ENDDO
crem	close(unit=12)
crem	endif
crem	if (fm.eq.'f') then
crem	outfile(22:22)='f'												!Tamara
crem      OPEN(12,FILE=OUTFILE,ACCESS='APPEND') 
	DO J=1,JJ
	write(12,180) ayr,amn,ady(j),(datf(j,k),k=1,24)
	write(*,180) ayr,amn,ady(j),(datf(j,k),k=1,24)
	ENDDO
	close(unit=12)
crem	endif
crem	if (fm.eq.'h') then
crem	outfile(22:22)='h'												!Tamara
crem      OPEN(12,FILE=OUTFILE,ACCESS='APPEND') 
	DO J=1,JJ
	write(14,181) ayr,amn,ady(j),(dath(j,k),k=1,24)
	write(*,181) ayr,amn,ady(j),(dath(j,k),k=1,24)
	ENDDO
crem	close(unit=12)
crem	endif
  180	format(3A2,2X,24(A5))
  181	format(3A2,1X,24(A5))
C
c	pause ' '
	goto 2
    3	continue
c-      write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
c-	write(*,*) infile
c	pause ' '
crem	if (fm.eq.'f') then
	datf(jj,jut)=' 00  '
crem	else
      datm(jj,jut)=' 000 '
	  dath(jj,jut)=' 000 '
crem	endif
	close(unit=11)
	goto 1110
   2  CONTINUE    
crem      CLOSE (unit=12)
crem	if (fm.eq.'f') then
crem	fm='m'
crem	goto 101
crem	endif

crem	if (fm.eq.'m') then
crem	fm='h'
crem	goto 101
crem	endif

       END DO     
crem	pause ' '
crem      STOP

  
      RETURN
	END
c
c
c
c
C ===============================================================
C     !
C ===============================================================
C  NEW SUBROUTINE to check letters in input data:					 
	subroutine replets(aaa,bbb)
C .......................................................April 2010
      CHARACTER*5 aaa,bbb
	CHARACTER*1 IN(0:11),x1,x2,x3,x4,x5						 
	DATA IN/'0','1','2','3','4','5','6','7','8','9',' ','.'/	
      x1=aaa(1:1)
	x2=aaa(2:2)
	x3=aaa(3:3)
	x4=aaa(4:4)
	x5=aaa(5:5)
	ic1=-1
	ic2=-1
	ic3=-1
	ic4=-1
	ic5=-1
	do i=0,11
	if (x1.eq.in(i)) ic1=i
	if (x2.eq.in(i)) ic2=i
	if (x3.eq.in(i)) ic3=i
	if (x4.eq.in(i)) ic4=i
	if (x5.eq.in(i)) ic5=i
	enddo
	if ((ic1.eq.-1).or.(ic2.eq.-1).or.(ic3.eq.-1).or.(ic4.eq.-1).
     *or.(ic5.eq.-1)) then	  
     	if (ic3.eq.11) then
	 bbb='  00 '
	else
	bbb=' 000 '
	endif
	                else
	bbb=aaa
	endif
	if ((ic1.eq.10).and.(ic2.eq.10).and.(ic3.eq.10).and.(ic4.eq.10).
     *and.(ic5.eq.10)) then
	bbb='0000 '
	endif
	return
	end
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

