C ===========================================================
	PROGRAM EXTDATA3
C                                                             ! Nov. 2011   
C   infile0, 1 ='d:\web\dat1\YY\moYRMN.txt'  infile2='d:\web\graf\MA\ma155_2011XXXUT0000.SAO'
C   EXTRACT foF2 FROM DAILY-HOURLY FILE DPS SAO FILE, => infile2
c   EXTRACT 96 HOURLY "FOF2" from d:\web\dat1\YR\moyrmn.txt for 96 prec. hours => infile1
C               Send output results to d:\web\graf\dias\fof2-pred.txt files..= outfile1
C               Keep intermediate results in 'd:\web\graf\dias\fof2-96.txt' = outfile2
C   txt   fof2-pred.txt  fof2-96.txt     
c
      DIMENSION XF(0:96),IXF(4,0:96),XRES(0:23),IM(12),
     *XX(15),dat(60),IYMD(5,3),rx(0:23),COEFA(74),COEFB(74),
     *FU1(24),FU2(24),FUA(5,24),FUB(5,24),
     *DA(5,0:23) ! 4 prec_days+curr_day=5
      INTEGER*2 jyr,jmn,jdy,jyr_pre,jmn_pre,jdy_pre
      CHARACTER*120 infile0,infile1,infile2,outfile1,outfile2,timefile,txt        !Ljuba  timefile (  graf/UT_time)
 	CHARACTER*10 CCM
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 YEAR,YEARbeg,TTT                       !Ljuba  YEARbeg -    
	CHARACTER*6 YYMMDD
	CHARACTER*13 dd1,CC1
	CHARACTER*3 DOY,DOYpre,DOYbeg                      !Ljuba  DOYpre -  , DOYbeg -     
      CHARACTER*1 AMM,SOUT
 	CHARACTER*2 ST,AMN,DD2,AYR,ADY,AUT,CUT,DD3,
     *PYR_pre,PMN_pre                                     !Ljuba   DD3 -      
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA COEFA/
     &.2588190, .5, .7071068, .8660254, .9659258,1.0,.9659258,.8660254
     &, .7071067, .5, .2588190, .0,-.2588191,-.5,-.7071068,-.8660254,
     &-.9659259,-1.0,-.9659258,-.8660253,-.7071066,-.5,-.2588189, .0
     &,.5,.8660254,1.0,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5
     &,.0, .7071068, 1.0, .7071067, .0,-.7071068,-1.0,-.7071066, .0      
     &, .8660254, .8660254, .0,-.8660254,-.8660253, .0
     &,.9659258,.5,-.7071068,-.8660253,.2588192,1.0,.2588188,-.8660256
     &,-.7071065, .5, .9659257,.0,-.9659259,-.5, .7071072,.8660251
     &,-.2588196,-1.0,-.2588184, .8660257, .7071062,-.5,-.9659256, .0/
	DATA COEFB/
     &.9659258, .8660254, .7071068, .5, .2588190, .0,-.2588191,-.5
     &,-.7071068,-.8660254,-.9659259,-1.0,-.9659258,-.8660253,-.7071067
     &,-.5,-.2588189,.0, .2588192,.5,.7071069, .8660255, .9659259, 1.0     
     &,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5,.0,.5,.8660255
     &,1.0, .7071068, .0,-.7071068,-1.0,-.7071067, .0, .7071069, 1.0
     &, .5,-.5,-1.0,-.5, .5, 1.0
     &, .2588190,-.8660254,-.7071067, .5, .9659258, .0,-.9659259,-.5
     &,.7071070,.8660252,-.2588194,-1.0,-.2588186,.8660257,.7071064,-.5
     &,-.9659257, .0, .9659260, .5,-.7071073,-.8660250, .2588198, 1.0/
C
C  Re-arrange coefficients for Ai, Bi:
	DO JCASE=1,5
	select case (jcase)
	case (1)
    	do i=1,24
    	fu1(i)=coefa(i)
	fu2(i)=coefb(i)
	enddo
	goto 6
	case (2)
    	do i=1,12 
      fu1(i)=coefa(i+24)
      fu1(i+12)=fu1(i)
	fu2(i)=coefb(i+24)
	fu2(i+12)=fu2(i)
	enddo
	goto 6
	case (3)
    	do i=1,8 
    	fu1(i)=coefa(i+36)
	fu1(i+8)=fu1(i)
	fu1(i+16)=fu1(i)
	fu2(i)=coefb(i+36)
	fu2(i+8)=fu2(i)
	fu2(i+16)=fu2(i)
	enddo
	goto 6
	case (4)
    	do i=1,6 
    	fu1(i)=coefa(i+44)
	fu1(i+6)=fu1(i)
	fu1(i+12)=fu1(i)
	fu1(i+18)=fu1(i)
	fu2(i)=coefb(i+44)
	fu2(i+6)=fu2(i)
	fu2(i+12)=fu2(i)
	fu2(i+18)=fu2(i)
	enddo
	goto 6
	case (5)
    	do i=1,24
    	fu1(i)=coefa(i+50)
	fu2(i)=coefb(i+50)
	enddo
	goto 6
	end select
C
    6		do nn=1,24
      FUA(jcase,nn)=fu1(nn)
	FUB(jcase,nn)=fu2(nn)
	enddo
	ENDDO
C Start:
C    
	st='mo'		! Moscow

C
C read preceding 96 values: iyr,imn,idy,iut,fof2
C
C
c	 Next lines = specify path and name of Output file:
C
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
       TTT(1:4)=TT(1:4)								 !Ljuba
	YEAR=DD(1:4)									 !Ljuba
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT !Tamara

       timefile='/var/www/izmiran/ionosphere/weather/graf/UT_time'
   50	FORMAT(A4,1x,A2,1x,A2,1x,A3,1x,A2,1x,A4,1x,A2,1x,A2,1x,A3,A10)
       OPEN(13,FILE=timefile,STATUS='OLD')
       read (13,50)YEAR,AMN,DD2,DOYpre,AUT,YEARbeg,PMN_pre,DD3,DOYbeg       !Ljuba YEAR ,,,,UT - , 
       close(unit=13)                                                       !Ljuba AYR ,,, -   
	WRITE(*,*) 'Reading file UT_time: YEAR=',YEAR, ' AMN=', AMN,' DD2=', DD2,' DOYpre=', DOYpre, ' AUT=', AUT  
	WRITE(*,*) ' YEARbeg=',YEARbeg, ' PMN_pre=', PMN_pre, ' DD3=', DD3, ' DOYbeg=',DOYbeg  

C	write(*,*) ' Enter YEAR' 							!  Ljuba	 !Tamara
C	read(*,*) YEAR								!  Ljuba	 !Tamara
C            TTT(1:4)=YEAR                                                   !Ljuba   =YEAR     UT_time .
C	AYR=YEAR(3:4)                                                         !  Ljuba
       AYR=YEARbeg(3:4)                                         ! Ljuba      =pyr_pre ?     UT_time .
       write(*,*) ' AYR=YEARbeg(3:4) = ', AYR
	pyr_pre=AYR ! prec_year
	read(ayr,*) ryr
	jyr=int(ryr)
C
C	write(*,*) ' Enter MN, DY:' 			       !  Ljuba	 !Tamara
C	read(*,*) AMN,DD2						!  Ljuba		 !Tamara
crem	AMN=DD(5:6)							!Ljuba   =AMN     UT_time . 
crem      DD2=DD(7:8)		                         	!Ljuba   =DD2     UT_time . 
	YYMMDD(1:2)=AYR


	YYMMDD(3:4)=AMN
	YYMMDD(5:6)=DD2
	read(amn,*) rmn
	jmn=int(rmn)
C
	read(dd2,*) rdy2
	kdy2=int(rdy2)      ! current day 
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
C	write(*,*) ' Enter UT' 						!  Ljuba	  !Tamara
C	read(*,*) AUT	                                                 !  Ljuba !Tamara
C	AUT=TTT(1:2)			!  Ljuba   UT  =AUT     UT_time .								  
      	read(aut,*) ut
 	jut=int(ut)
C
C preceding month:
	if (jmn.gt.1) then
	jmn_pre=jmn-1			 ! prec_mn
      jyr_pre=jyr
	PYR_pre=AYR
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=jyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR_pre)  ! prec_yr
	endif
	call blet2(jmn_pre,PMN_pre)   ! prec_mn
C
	CCM=YEAR
	CCM(5:5)=' '
	CCM(6:7)=AMN
	CCM(8:8)=' '
C
  134  CONTINUE
c
C
C	infile0='d:\web\dat1\YY\moYRMN.txt'   ! preceding mn      !Tamara
C	infile0(13:14)=pyr_pre										 !Tamara
C 	infile0(18:19)=pyr_pre										 !Tamara
C	infile0(20:21)=pmn_pre										 !Tamara
C	 infile1=infile0  ! current mn
C	infile1(13:14)=ayr										 !Tamara
C 	infile1(18:19)=ayr										 !Tamara
C	infile1(20:21)=amn										 !Tamara
C =======================================================
	infile0='/var/www/izmiran/ionosphere/weather/dat1/YY/moYRMN.txt'  
C	infile0(42:43)=pyr_pre	
       infile0(42:43)=YEARbeg(3:4)		! LIUBA 03-01-2013							 !YY
C 	infile0(47:48)=pyr_pre							 !YR
       infile0(47:48)=YEARbeg(3:4)	        ! LIUBA 03-01-2013
	infile0(49:50)=pmn_pre										 !MN
	 infile1=infile0  ! current mn
	infile1(42:43)=AYR										 !YY
 	infile1(47:48)=AYR										 !YR
	infile1(49:50)=amn	                                     !MN
	write(*,*) ' infile0=', infile0
C =======================================================

C Avoid input of prec. month if current day >4
	if (kdy2.gt.4) GOTO 130						 !!!
C =======================================================
C
  117	FORMAT(3I2,2X,24(F3.1,2X))		   
C
C  day-to-day input for prec mon
C
	nndy=im(jmn_pre)	  ! prec. mn
		OPEN(10,FILE=INFILE0)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
	enddo
	DO jdy_pre=1,nndy  ! 
C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=116) iiy,iim,iid,(rx(k),k=0,23)
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,23
	da(5,k)=rx(k)
	enddo
C move data up by 1 line
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,23
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
      ENDDO
  116	close(unit=10)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C input for current mn
  130	continue
C
		OPEN(10,FILE=INFILE1)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
	enddo
	kk=0
	DO jdy=1,kdy2  ! 
C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=118)  iiy,iim,iid,(rx(k),k=0,23)
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,23
	da(5,k)=rx(k)
	enddo

	kk=kk+1
	if (kk.lt.kdy2) then

C move data up by 1 line
	
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,23
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
	endif
  	ENDDO
  118	close(unit=10)
C
C re-arrange data for 96 prec. hours:
	kk=0
C
	 kut=jut
	jj1=1
	jjend=4
  123	IXF(1,kk)=iymd(jj1,1)
	IXF(2,kk)=iymd(jj1,2)
	IXF(3,kk)=iymd(jj1,3)
	IXF(4,kk)=kut
      XF(kk)=da(jj1,kut)
	kk=kk+1
	if (kk.gt.95) goto 124
	kut=kut+1
	if (kut.gt.23) then
	kut=0
	jj1=jj1+1
	if (jj1.gt.5) goto 124
	endif
	goto 123
C
 124	call subfur(xf,xres)

C
  135	kdy=kdy2	 ! current day from Moscow DPS SAO file
C
	ADY=DD2
C
	read(ady,*) rdy
	jdy=int(rdy)

C Calculate day-of-year:
	lday=ndoy(jyr,jmn,jdy) ! function to define day-of-year
	call blet3(lday,DOY)

	write(*,17) doy
C
	dd1='AA20100560225'	   ! Moscow 
	dd1(5:6)=AYR
	 dd1(7:9)=DOY
	dd1(10:11)=AMN
	dd1(12:13)=ADY
C
C ==========================================================
C
C
crem      infile1='d:\web\dat1\YR\moyrmn.txt'                            !
crem      infile1(13:14)=AYR											   !
crem	infile1(18:19)=AYR												   !
crem	infile1(20:21)=AMN												   !
c
c	infile2='d:\web\graf\MA\ma155_2011XXXUT0000.SAO' !                 !
c      infile2(22:25)=YEAR												   !
c	infile2(26:28)=DOY												   !
c	infile2(29:30)=AUT
c ==========================================================
	infile2='/var/www/izmiran/ionosphere/weather/graf/MA/  
     *MA155_2011XXXUT0000.SAO' 
c!   MA->MO ma->mo      MA  
      infile2(51:54)=YEAR												   !!!!!!!
	infile2(55:57)=DOY												   !
	infile2(58:59)=AUT
	write(*,*) 'AUT, infile2=', AUT, infile2
c ==========================================================
c
   17	FORMAT(1X,A3)  ! Ljuba -  FORMAT(1X,'DOY='A3)

   19	format(A6)
   20	format(A13,A2,A1)
   21	format(A4)
   22	format(A2)
   23	format(15(F8.3))
   89	format(A120)
C
C
C
   1	continue
C ===================================
C
     	OPEN(11,FILE=INFILE2)
crem	CDAY(JD)=ADY 
C
	CCM(9:10)=ADY
	ist=0
	dat(1)=0.
  100	read(11,20,err=3,end=107) CC1,CUT,AMM
	goto 9
   10	continue
	 TT=CC1(1:2)
	if (TT.eq.' ') then
	goto 3
	endif
    9  continue 
 	if ((cc1.eq.dd1).and.(CUT.eq.AUT).and.(AMM.eq.'0')) then 
	goto 101			! select UT-hourly values
	else
	goto 100
	endif
  101 continue
	jj=0
      DO n=1,4
	read(11,23,end=107,err=107) (xx(k),k=1,15)
	do k=1,15
	if (xx(k).gt.999.) xx(k)=0.
	jj=jj+1
	dat(jj)=xx(k)
	enddo
	ENDDO  
 107  close(unit=11)
111	 XFOF2=dat(1)
C ==========================================================
  	ifof2=nint(xfof2*10.)	 ! foF2*10
	sout=' '
      if (ifof2.eq.0) then 
	xfof2=xres(jut)             ! xres(0)?
	ifoF2= nint(xfof2*10.) ! missed foF2 = furie prediction
	sout='*'
	write(*,*) ' Missed foF2=',ifof2,sout
	endif
C new array for MOS:===============
	ixf(1,96)=jyr
	ixf(2,96)=jmn
	ixf(3,96)=jdy
	ixf(4,96)=jut
	xf(96)=xfof2
C Shift 96 values by 1 h up:
	do n=1,96
	do k=1,4
	ixf(k,n-1)=ixf(k,n)
	enddo
	xf(n-1)=xf(n)
	enddo
	call subfur(xf,xres)
C ========================================
   11	continue
  440 CLOSE (unit=11)
C Output of foF2-pred.txt
C	OUTFILE1='d:\web\graf\dias\fof2-pred.txt' !
       OUTFILE1='/var/www/izmiran/ionosphere/weather/graf/f/fof2-pred'  ! Liuba
	OPEN(12,FILE=OUTFILE1)
	kut=jut
	kdy=jdy
	do kk=0,23
	kut=kut+1
	if (kut.gt.23) then
	kut=0
	kdy=kdy+1
	endif
c???	fpred=xres(kut)
	fpred=xres(kk)	  ! Check
	write(12,87) jyr,jmn,kdy,kut,fpred
	write(*,87) jyr,jmn,kdy,kut,fpred
	enddo
	close(unit=12)
   87	format(4(I2,1X),1X,F4.1)					!NEW
C Keep updated outfile2:
C	outfile2='d:\web\graf\dias\fof2-96.txt'
       outfile2='/var/www/izmiran/ionosphere/weather/graf/f/fof2-96'
		OPEN(12,file=outfile2)
	do nn=1,96
	ifof2=nint(xf(nn-1)*10.)
	write(*,88) (IXF(k,nn-1),k=1,4),ifof2
	write(12,88) (IXF(k,nn-1),k=1,4),ifof2
	enddo

   77 continue                 ! go to the next day
   88	format(4(I2,1X),1X,I3)					!NEW
C End of  ===============
C Add output to graf/2011/mo11f.br including sout(*), mo11h.br ++++++++++++
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=11)
	 CLOSE (unit=12)
C	pause ' '       ! Liuba 
C	STOP            ! Liuba 
	END
C
      subroutine blet2(ilet,alet2)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
CLjuba	a2='00'
	alet2='00'             !
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
C
C
      subroutine blet3(ilet,alet3)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*3 alet3
C	a3='000'  ! Ljuba  a3='000'
C
	j100=ilet/100
	      j10=(ilet-j100*100)/10
	j1=ilet-j100*100-j10*10
    3	do i=0,9
		if (j100.eq.i) then
	alet3(1:1)=IN(i)
	endif
	enddo
    5	do i=0,9
	if (j10.eq.i) then
	alet3(2:2)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet3(3:3)=IN(i)
	endif
	enddo 
	return
	end
C================================================================
      subroutine subfur(fdat,fres)
C.......................................................Nov. 2011
C Furie expansion of diurnal foF2 using 96 prec. values 
      dimension fdat(0:96),fres(0:23),
     *AI(5),BI(5),FUA(5,24),FUB(5,24)
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie for Ai, Bi
	PARAMETER (n=96,p=24.,pip=.2617994)
C
C Parameters:
c	PI=ATAN(1.0)*4.
c	P=24.
c	N=96
c	 pip=2*pi/p 
C
crem
C mean of 96 values:
	xav=0.
	do i=0,N-1
	xav=xav+fdat(i)
	enddo
	xav=xav/N
C
	do ii=1,5
	  ai(ii)=0.
	  bi(ii)=0.
	  DO nn=1,4  ! 4 times repeat coefs. for Ai and Bi
	     do j=1,24  ! set of coefficiens
	       nj=j-1+(nn-1)*24
	       xval=fdat(nj)
c
	       ai(ii)=ai(ii)+xval*fua(ii,j)
	       bi(ii)=bi(ii)+xval*fub(ii,j)
	     enddo
	  ENDDO
	  ai(ii)=ai(ii)*2./N
	  bi(ii)=bi(ii)*2./N
	enddo
C synthesis
		sum=xav
	do iut=0,23
	fres(iut)=xav
	do ii=1,5
	fres(iut)=fres(iut)+ai(ii)*fua(ii,iut+1)+
     *bi(ii)*fub(ii,iut+1)
	 enddo
	enddo
  101	CONTINUE
crem	close (unit=15)
	RETURN
	end

C ===============================================================
      integer function ndoy(iyr,imn,idy)
C
	       DIMENSION IM(12)
	integer*2 iyr,imn,idy
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	z1=iyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+idy	
	END FUNCTION
C ===============================================================
