      program covtau27
C.......................................................................Feb. 2017
C Daily COV => cov(tau) for prec. 27 days 1947.03 - 2017.02
C if missed days during -27 days period recalculate T and tau excluding cov=0. days
C
	dimension covd(0:27)
	character*35 infilecv,outfilecv
	character*2 BMN(0:27),BDY(0:27),AYR,AMN,ADY
	character*4 BYEAR(0:27),AYEAR
C
	infilecv='Solar_radio_flux19472017.txt'
	outfilecv='covtau27.txt'
	OPEN(10,file=infilecv,action='READ')
C
   4	read(10,70) AYEAR,AMN,ADY
	if((AYEAR.eq.'1947').and.(AMN.eq.'02').and.(ADY.eq.'28')) then
	goto 2
	else
	goto 4
	endif
   70 format(A4,2A2)
C
   2	OPEN(11,file=outfilecv)
C	T=11.0
	T=27.0
	tau=exp(-1./T)
C	tau=0.96
	tau2=tau*tau
	tau3=tau2*tau
	tau4=tau3*tau
	dtau=1.0-tau
C tc(tau)=(1-tau)*(ap0+ap_1*tau+ap_2*tau2+ap_3*tau3)
	idy=0
   71 format(A4,2A2,4X,F5.1)
C    1	idy=idy+1
C	write(*,*) 'Enter ap for prec day'
    1	read(10,71,end=3) BYEAR(27),BMN(27),BDY(27),covd(27)
		idy=idy+1
C Move data 1 day up:
	do k=0,26
	 BYEAR(k)=BYEAR(k+1)
	 BMN(k)=BMN(k+1)
	 BDY(k)=BDY(k+1)
	 covd(k)=covd(k+1)
      enddo
	if (idy.lt.27) goto 1
C
C Check COV>0 cases during -27 days:
	cnt=0.
	 cov0=covd(0)
	do k=0,26
	if (covd(k).gt.0.) then
	cnt=cnt+1.
	cov0=covd(k)
	endif
	enddo
	T=cnt
	tau=exp(-1./T)
	dtau=1.0-tau
C TEC(tau)
      sum=cov0
	coef=1.
	do 25 k=25,0,-1
	if (covd(k).eq.0.) goto 25 
	coef=coef*tau
	add=covd(k)*tau
	sum=sum+add
Ctemp
      res=sum*dtau
   25	continue
	 AYEAR=BYEAR(27)
	AYR=AYEAR(3:4)
	AMN=BMN(27)
	ADY=BDY(27)
		read(AYEAR,*) ryear
	read(AYR,*) ryr
	jyr=int(ryr)
     	if(int(ryr/4.)*4.eq.jyr) THEN 
  	 dnr=366.
	                          ELSE
	dnr=365.
	ENDIF

		read(AMN,*) rmn
	jmn=int(rmn)
			read(ADY,*) rdy
 	jdy=int(rdy)
	 lda=ndoy(jyr,jmn,jdy)
	ryrout=ryear+lda/dnr-0.0027
	write(*,72) ryrout,AMN,ADY,res
	write(11,72) ryrout,AMN,ADY,res
	idy=idy-1  ! for adding next day data
	GOTO 1
   72 format(1X,F8.3,2(1X,A2),1X,F5.1)
   3	close(unit=10)
      close(unit=11)
	pause ' '
	stop
	end