C.......................................................May 2013
C Calculate cross-correlation of 2 arrays given lag=-6,-5,-4,...-1,0,1,...5, 6 hrs
C Model of Prpb. W+, W- versus Dst
C 
      program crosslag
C      output	cmaprms2.txt
C
      DIMENSION dinp(0:72,3),x(73),y(73),z(73)
	character*45 infile,outfile
	character*14 title
c
c
crem	infile='caver1.txt'
	infile='caver2.txt'
	outfile='crosslag.txt'
   21	format(1X,F9.4,2(4X,F6.5))
C
   18	OPEN(110,FILE=infile)
	OPEN(111,FILE=outfile,ACCESS='APPEND')
	read(110,*) title
      read(110,*) title
	do i=0,72
	read(110,21) (dinp(i,k),k=1,3) ! Dst, W+, W-
C Change arrays of W+ by W-:
	w1=dinp(i,2)		   ! W+
	dinp(i,2)=dinp(i,3)	   ! W-
	dinp(i,3)=w1		   ! W+
	enddo
      close(unit=110)
	do n=0,72
	x(n+1)=dinp(n,1)
	enddo
	do n=0,72
	y(n+1)=dinp(n,2)	   ! W+ probability
	enddo

Cycle on lag (delay of Wp after Dst)
	irun=0
  119	continue
	irun=irun+1 
      DO 120 lag=0,12
	nrun=73-lag
	sx=0.
	sy=0.
	do jj=1,nrun
	sx=sx+x(jj)
	z(jj)=y(jj+lag)
	sy=sy+y(jj)
	enddo
	sx=sx/nrun
	sy=sy/nrun
	sum1=0.
	sum2=0.
	sum3=0.
	do jj=1,nrun
	sum1=sum1+(x(jj)-sx)*(z(jj)-sy)
      sum2=sum2+(x(jj)-sx)**2
      sum3=sum3+(y(jj)-sy)**2
	enddo
	cxy=sum1/sqrt(sum2*sum3)
	write(*,22) irun,nrun,lag,cxy,x(1),y(1),z(1)
	write(111,22) irun,nrun,lag,cxy,x(1),y(1),z(1)
  120	continue
C
  22	format(1X,3(1X,I2),1X,F7.3,3(1X,F8.3))
	if (irun.eq.1) then
	do m=0,72
	z(m+1)=dinp(m,1)
	x(m+1)=dinp(m,2)
	y(m+1)=z(m+1)
	enddo
	goto 119
	else
	 GOTO 33
	endif

    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34
   33	continue
  98	close(unit=111)
      write(*,*) infile,infile,outfile
      pause ' ' 
   34   STOP
       END

