      program mosfhour
C..............................................................Mar. 2017
C correct production of Moscow f-plot,w-index plot
C
	dimension ixx(0:23),fmos(0:5,0:23),fmed(0:5,0:23),ipar(5,48)
	+,ff2(3,48),IM(12),iwdat(48),fdat(5,0:23),f96(0:96) !fdat for 96 prec hours + forecast for 24 hrs
	character*128 infilef,infilmed,parres,infdate,txt
	character*4 AYEAR,BYEAR,TTT
	character*2 AYR,BYR,AMN,BMN,ADY,BDY,CYR,CMN,CDY
	character*3 ALDA,BLDA
 		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/    !

	CALL DATE_AND_TIME(DD,TT,ZZ)
      TTT(1:4)=TT(1:4)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT
C
      CALL HARMONIC										  !
C
	do k=1,48
      do i=1,5
	ipar(i,k)=0
	enddo
	do i=1,3
	ff2(i,k)=0.
	enddo
	iwdat(k)=0
	enddo

C	
	infilef='d:\web\graf\2017\moYRf.br'
	infilmed='d:\web\graf\dat2\17\moYRMNm.txt'
	infdate='d:\web\graf\date'
	parres='d:\web\graf\f\Par_gr'
C
	OPEN(10,file=infdate,action='READ')
   21	format(A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,A3))
   22	format(A128)
	read(10,21) AYEAR,AMN,ADY,BYEAR,BMN,BDY,ALDA,BLDA
	close(unit=10)
C
       read(ALDA,*) rlda
	lda=int(rlda)
	       read(BLDA,*) rldb
	 ldb=int(rldb)

C       call sublet3(lda,ALDA)
c	  call sublet3(ldb,BLDA)
	AYR=AYEAR(3:4)
	BYR=BYEAR(3:4)
	read(AYR,*) ryr
	read(BYR,*) ryr0
	iyr_pre=int(ryr0)
	read(BMN,*) rmn0
	imn_pre=int(rmn0)
	read(BDY,*) rdy0
	idy_pre=int(rdy0)
C
	kyr=int(ryr)
	infilef(13:16)=AYEAR
	infilmed(18:19)=AYR
	infilef(20:21)=AYR
	infilmed(23:24)=AYR
C
	read(AMN,*) rmn
	kmn=int(rmn)
	read(ADY,*) rdy
	kdy=int(rdy)
C
		z1=kyr/4.0						  !
      jz1=int(z1)*4                     ! 
      IF(jz1.EQ.kyr) THEN				  !
               IM(2)=29				  !
      yds=366.
	  ELSE							  !
                IM(2)=28				  !
	yds=365.
	       ENDIF					  !
C
	kdy_pre=kdy-1
	kmn_pre=kmn
	kyr_pre=kyr
	if (kdy_pre.eq.0) then
	kmn_pre=kmn-1
	if (kmn_pre.eq.0) then
	kyr_pre=kyr-1
	kmn_pre=12
	endif
	kdy_pre=im(kmn_pre)
	endif
C=======================================
C check preceding last UT month and day:
	OPEN(10,file=parres,action='READ')
	do k=1,24
	read(10,*) nn,nyr,nmn,ndy,nut
	enddo
	close(unit=10)
c-	if ((nyr.eq.kyr_pre).and.(nmn.eq.kmn_pre).and.(ndy.eq.kdy_pre)
c-	+.and.(nut.lt.23)) then
C?	call submos(BYEAR,BMN,BDY,BLDA)  ! read data for prec. day
c-	endif
C========================================
C?        call submos(AYEAR,AMN,ADY,ALDA)
C
      write(*,*) 'Enter UT-start:' !C//
	read(*,*) kuthr              !C//
C//      kuthr=nut+1       ! New UT
C//	if (kuthr.gt.23) then
C//	kuthr=0
C//	idy=kdy
C//	imn=kmn
C//	iyr=kyr
C//                 else
	idy=kdy_pre
	imn=kmn_pre
	iyr=kyr_pre
C//	endif
	iut=kuthr
C
C
   56	DO 55 nn=1,48  !+++++++
	ipar(1,nn)=nn
	ipar(2,nn)=iyr
	ipar(3,nn)=imn
	ipar(4,nn)=idy
	if((idy.eq.1).and.(nn.le.24)) then
	ipar(2,nn)=iyr_pre
	ipar(3,nn)=imn_pre
	ipar(4,nn)=idy_pre
	endif
	ipar(5,nn)=iut
	iut=iut+1
	     if (iut.le.23) then
			goto 55
	           else
	iut=0
	idy=idy+1
	if (idy.gt.im(imn)) then
	idy=1
	imn=imn+1
	endif
	endif
   55	CONTINUE
C/	ipar(5,48)=ipar(5,47)+1
C
	lda_4=ldb-2        ! -4 day
	idy_4=kdy_pre-3
	imn_4=kmn_pre
	if (idy_4.le.0) then
	imn_4=imn_4-1
	idy_4=im(imn_4)+idy_4
	endif

	kutend=kuthr-1
	kdyend=kdy
	jdy=idy_4
	jmn=imn_4
C
   23	format(3A2,1X,24(1X,I3,1X))									
      OPEN(12,file=infilef,action='READ')
C
C
C read foF2
C
   61	read(12,23,end=62) CYR,CMN,CDY,(ixx(k),k=0,23)
      do k=0,23
      fmos(5,k)=float(ixx(k))/10.
	enddo
C Move data 1 line up
	do k1=1,5
	do k2=0,23
	fmos(k1-1,k2)= fmos(k1,k2)
	enddo
	enddo
	if ((cyr.eq.ayr).and.(cmn.eq.amn).and.(cdy.eq.ady)) then 
	goto 62
	             else
	goto 61
	endif
   62	close(unit=12)
C
      infilmed(25:26)=AMN
	if (imn.ne.imn_pre) then
      infilmed(25:26)=BMN
	endif
      OPEN(13,file=infilmed,action='READ')
	do i=1,4
	read(13,22) txt !extra line
	enddo
C
C Read Median
C 
   63 read(13,23,end=64) CYR,CMN,CDY,(ixx(k),k=0,23)
      do k=0,23
      fmed(5,k)=float(ixx(k))/10.
	enddo

C Move data 1 line up
	do k1=1,5
	do k2=0,23
	fmed(k1-1,k2)= fmed(k1,k2)
	enddo
	enddo
	if ((cyr.eq.ayr).and.(cmn.eq.amn).and.(cdy.eq.ady)) then 
	goto 64
	             else
	goto 63
	endif
C
   64	close(unit=13)
	 ncnt=0
      DO jj=1,5	   !>>>>>>>>>>>>>>>>>
C
	if (jj.eq.1) then
	DO jut=kuthr,23
	f96(ncnt)=fmos(0,jut)
	if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(5,jut) !++
	ff2(3,ncnt+1)=fmed(4,jut)
	ncnt=ncnt+1
	ENDDO
	endif
	if (jj.eq.2) then
	DO jut=0,23
	f96(ncnt)=fmos(1,jut)
	if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(5,jut)
	if (jut.lt.kuthr) ff2(3,ncnt+1)=fmed(5,jut)
	ncnt=ncnt+1
	ENDDO
	endif
	if (jj.eq.3) then
	DO jut=0,23
	f96(ncnt)=fmos(2,jut)
	if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(5,jut) !++
	ncnt=ncnt+1
	ENDDO
	endif
		if (jj.eq.4) then
 	DO jut=0,23
	f96(ncnt)=fmos(3,jut)
	if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(5,jut) !++
	ncnt=ncnt+1
	ENDDO
	endif
		if (jj.eq.5) then
 	DO jut=0,kuthr
	f96(ncnt)=fmos(4,jut)
	if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(5,jut) !++
	ncnt=ncnt+1
	ENDDO
	endif
	ENDDO			!>>>>>>>>>>>>>>>>>>>>>
      do jj=1,24
	ff2(3,jj+24)=ff2(3,jj) ! med for next 24 hrs
	enddo
C
	nn=0
	DO jj=1,4
		do kk=0,23
	fdat(jj,kk)=f96(nn)
	nn=nn+1
	enddo
	ENDDO
	DO kk=0,23
	fdat(5,kk)=0.
	enddo
	CALL subfur4a(fdat)
C
	 DO mm=1,24
	ff2(3,mm+24)=ff2(3,mm) ! median
Crem	ff2(1,mm)=fdat(4,mm-1)  ! current foF2
	ndy=ipar(4,mm)
	nut=ipar(5,mm)
	if (ndy.eq.kdy_pre) then
	ff2(1,mm)=fmos(3,nut)
	else
	ff2(1,mm)=fmos(4,nut)
	endif
	ff2(2,mm)=-2.  			 ! no forecast
	ff2(2,mm+24)=fdat(5,mm-1)	 ! forecast foF2
	ff2(1,mm+24)=-2.		  ! no data
	if (fdat(4,mm-1).eq.ff2(3,mm)) then       !Tamara
	iw=0						              !Tamara
	goto 27				            		 !Tamara
	endif						             !Tamara
	 xpar=fdat(4,mm-1)**2
	xmed=ff2(3,mm)**2
	if (xpar.eq.0.) then
	iw=0
	goto 27
	endif
	call windex1(xpar,xmed,iw)
   27   iwdat(mm)=iw
	 xpar1=fdat(5,mm-1)**2
	call windex1(xpar1,xmed,iw)
	iwdat(mm+24)=iw
	ENDDO
C
C   Output results
C
  24	format(1X,I2,4(1X,I3),3(1X,F5.1),3X,I2)
	ipar(5,48)=ipar(5,47)+1
		OPEN(11,file=parres)  ! outfile

	DO ii=1,48
	if (ff2(1,ii).eq.0.0) ff2(1,ii)=-1.0
	write(*,24) (ipar(k,ii),k=1,5),(ff2(k,ii),k=1,3),iwdat(ii)
	write(11,24) (ipar(k,ii),k=1,5),(ff2(k,ii),k=1,3),iwdat(ii)
	ENDDO
	close(unit=11)
C
      pause ' '
	STOP
	END
C -----------------------------------------------------------
C
      subroutine blet3(ilet,alet3)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*3 alet3
	alet3='000'
C
	j100=ilet/100
	      j10=(ilet-j100*100)/10
	j1=ilet-j100*100-j10*10
    3	do i=0,9
		if (j100.eq.i) then
	alet3(1:1)=IN(i)
	endif
	enddo
    5	do i=0,9
	if (j10.eq.i) then
	alet3(2:2)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet3(3:3)=IN(i)
	endif
	enddo 
	return
	end
C==========================================================
