      program stormhrs
C.............................................Aug. 2015
C  AE (94 storms with AEs<=900 nT); Dst storms (Dst<=-100 nT; Wp storma
C
	dimension per(17),res(17)
c      CHARACTER*4 CYEAR
c	      CHARACTER*2 CYR
	CHARACTER*25 INFILE,OUTFILE,txt
C=	infile='aestorm2.txt'	   !AE storm with AEproxy > 900 nT
	infile='dststorm9915.txt'	   !  Dst storms Dst < -50 nt for 1999-2015
C=      	infile='Wpstorms.txt'		 ! Wp storms
	outfile='stormhrs.txt'
   31	format(A25) 
C=  32	format(9X,2I2,1X,I2,41X,I4)  !AE storms
   32	format(9X,2I2,1X,I2,19X,F5.0,16X,I4)  !Dst storms
C=   32	format(6X,I2,1X,I2,1X,I2,39X,I4)	     !Wp storms
		OPEN(11,FILE=INFILE)
	read(11,31) txt		 ! extra line
		OPEN(12,FILE=OUTFILE,access='APPEND')	
C
	cntot=0.
	iyear=1998
	icyr=98
	kout=1
	do 15 kk=1,17
	cntyr=0.
	res(kk)=0.
      iyear=iyear+1 !1999-2015.07
	YEAR=float(iyear)
c	call blet4(iyear,CYEAR)
C	CYR=CYEAR(3.4)
C	read(CYR,*) ryr
C	icyr=year-int(year/100.)*100.
	icyr=icyr+1
	if (icyr.eq.100) icyr=0

      IF ((YEAR/4.).EQ.IFIX(YEAR/4.)) THEN 
	NDNR=366.
	ELSE 
	NDNR=365.
	ENDIF
C=   1	read(11,32,END=16) JYR,JMN,JDY,idur ! AE, Wp
   1	read(11,32,END=16) JYR,JMN,JDY,dstmin,idur  !Dst storms
	if (dstmin.gt.-100.) goto 1 ! Exclude moderate Dst storms
	IF (JYR.eq.ICYR) THEN
c	if (jyr.eq.99) kout=1
	if ((jyr.ge.0).and.(JYR.lt.20)) kout=jyr+2
	cntyr=cntyr+1.
	res(kout)=res(kout)+idur
	cntot=cntot+float(idur)
	goto 1
	             ELSE
	BACKSPACE(11)
c	inext=icyr+1
c	if (inext.eq.100) inext=0
c	if (jyr-icyr.gt.1) then
c	kout=kout+1
	write(*,35) iyear,cntyr   ! annual storms number
		write(12,35) iyear,cntyr
	goto 15
c	else
c	goto 15
c	endif
	            ENDIF
   15	continue
   16	close(unit=11)
	write(*,33) infile,cntot
	write(12,33) infile,cntot
	iyear=1998
	do kk=1,17
	iyear=iyear+1
	per(kk)=res(kk)/cntot*100.
	write(*,34) iyear,res(kk),per(kk)
	write(12,34) iyear,res(kk),per(kk)
	enddo
  33	format(1X,A25,1X,F6.0)
  34	format(1X,I4,1X,F6.0,1X,F7.3)
  35	format(1X,I4,1X,F6.0)
	close(unit=12)
	pause ' '
	stop
	end
